--[[

]]
local FOLDER_NAME, SSA = ...

local Auras = LibStub("AceAddon-3.0"):NewAddon("ShamanAuras", "AceConsole-3.0","AceEvent-3.0", "AceHook-3.0", "AceTimer-3.0");
Auras.version = GetAddOnMetadata(FOLDER_NAME, "Version")
Auras:RegisterChatCommand("ssa","ChatCommand");
local L = LibStub("AceLocale-3.0"):GetLocale("ShamanAuras", true)

--local obj = {}
local caster,cooldown,duration = {},{},{};
local smallSpells = {};
local spellobj,totemObj,targetObj,miscObj,spells,ignoreSpells,GUIDs = {},{},{},{},{},{},{};
local loadedBuffBars,loadedMainBars,loadedUtilBars = {},{},{};
local talents,execTime = {},{};
local isFireStormElemental,isEarthElemental,isTotemMastery = false,false,false;
local spec = nil;
-- Booleans
local isIcefury = false;
local tempBool = false;



-------------------------------------------------------------------------------------------------------
----- Initialize Global Variables
-------------------------------------------------------------------------------------------------------
SSA.BackdropCB = {
	bgFile    = "Interface\\AddOns\\ShamanAuras\\media\\textures\\background_flat",
	edgeFile  = "Interface\\AddOns\\ShamanAuras\\media\\textures\\UI-Tooltip-Border",
	tile      = false,
	tileSize  = 16, 
	edgeSize  = 16, 
	insets     = {
		left = 4,
		right = 4,
		top = 4,
		bottom = 4,
	},
};

SSA.BackdropSB = {
	bgFile   = "Interface\\Tooltips\\UI-Tooltip-Background",
	edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
	tile = true,
	tileSize = 16,
	edgeSize = 10
}
SSA.BackdropFrm = {
	bgFile   = "Interface\\BUTTONS\\WHITE8X8.blp",
	edgeFile = "Interface\\BUTTONS\\WHITE8X8.blp",
	tile = false, tileSize = 0, edgeSize = 1,
	insets = { left = 0, right = 0, top = 0, bottom = 0}
}
SSA.grid = CreateFrame('Frame', 'AuraGrid', UIParent)
SSA.IsMovingAuras = false;
SSA.ButtonFont = CreateFont("SSAButtonFont");
local ButtonFont = SSA.ButtonFont;
ButtonFont:SetFont("Interface\\addons\\ShamanAuras\\Media\\fonts\\Continuum_Medium.ttf",12,"OUTLINE");
ButtonFont:SetJustifyH("CENTER");


SSA.MoveEnh = CreateFrame("Frame","MoveEnh",UIParent);
SSA.MoveRes = CreateFrame("Frame","MoveRes",UIParent);

------------------------------
--- For Debugging Purposes ---
------------------------------
--[[local ApplicantTemplate = CreateFrame("Frame","ApplicantTemplate",UIParent)
ApplicantTemplate:SetWidth(250)
ApplicantTemplate:SetHeight(30)
ApplicantTemplate:SetPoint("CENTER",UIParent,"CENTER",0,0)
ApplicantTemplate:SetBackdrop(SSA.BackdropSB);
ApplicantTemplate:Show();


ApplicantTemplate.button = CreateFrame("Button","InviteButton",ApplicantTemplate)
ApplicantTemplate.button:SetWidth(50)
ApplicantTemplate.button:SetHeight(20)
ApplicantTemplate.button:SetPoint("RIGHT",ApplicantTemplate,"RIGHT",-10,0)
--ApplicantTemplate.button:SetBackdrop(SSA.BackdropSB);
ApplicantTemplate.button:SetText("Button");
ApplicantTemplate.button:SetNormalFontObject("GameFontNormal")

ApplicantTemplate.button.ntex = ApplicantTemplate.button:CreateTexture()
ApplicantTemplate.button.ntex:SetTexture("Interface/Buttons/UI-Panel-Button-Up")
ApplicantTemplate.button.ntex:SetTexCoord(0, 0.625, 0, 0.6875)
ApplicantTemplate.button.ntex:SetAllPoints()	
ApplicantTemplate.button:SetNormalTexture(ApplicantTemplate.button.ntex)

ApplicantTemplate.button.htex = ApplicantTemplate.button:CreateTexture()
ApplicantTemplate.button.htex:SetTexture("Interface/Buttons/UI-Panel-Button-Highlight")
ApplicantTemplate.button.htex:SetTexCoord(0, 0.625, 0, 0.6875)
ApplicantTemplate.button.htex:SetAllPoints()
ApplicantTemplate.button:SetHighlightTexture(ApplicantTemplate.button.htex)

ApplicantTemplate.button.ptex = ApplicantTemplate.button:CreateTexture()
ApplicantTemplate.button.ptex:SetTexture("Interface/Buttons/UI-Panel-Button-Down")
ApplicantTemplate.button.ptex:SetTexCoord(0, 0.625, 0, 0.6875)
ApplicantTemplate.button.ptex:SetAllPoints()
ApplicantTemplate.button:SetPushedTexture(ApplicantTemplate.button.ptex)]]

SSA.ErrorFrame = CreateFrame("Frame",nil,UIParent);
_G["SSA_ErrorFrame"] = SSA.ErrorFrame;
local ErrorFrame = SSA.ErrorFrame;
ErrorFrame:SetWidth(260);
ErrorFrame:SetHeight(665);
ErrorFrame:SetPoint("TOPLEFT",UIParent,"TOPLEFT",100,-100);
ErrorFrame:SetBackdrop(SSA.BackdropSB)
ErrorFrame:SetBackdropColor(0.15,0.15,0.15,0.9);
ErrorFrame:SetBackdropBorderColor(1,1,1,1);
ErrorFrame:Hide();

ErrorFrame.text = ErrorFrame:CreateFontString(nil, "MEDIUM", "GameFontHighlightLarge");
ErrorFrame.text:SetPoint("TOPLEFT",11,-5);
ErrorFrame.text:SetFont("Interface\\addons\\ShamanAurasDev\\Media\\fonts\\courbd.ttf", 14,"NONE");
ErrorFrame.text:SetTextColor(1,1,1,1);
ErrorFrame.text:SetJustifyH("LEFT");

------------------------------
--- For Debugging Purposes ---
------------------------------
local DataFrame = CreateFrame("Frame",nil,UIParent);
DataFrame:SetWidth(700);
DataFrame:SetHeight(300);
DataFrame:SetPoint("TOPLEFT",UIParent,"TOPLEFT",100,-100);
DataFrame:SetBackdrop(SSA.BackdropSB)
DataFrame:SetBackdropColor(0.15,0.15,0.15,0.9);
DataFrame:SetBackdropBorderColor(1,1,1,1);
DataFrame:Hide();

DataFrame.text = DataFrame:CreateFontString(nil, "MEDIUM", "GameFontHighlightLarge");
DataFrame.text:SetPoint("TOPLEFT",11,-5);
DataFrame.text:SetFont("Interface\\addons\\ShamanAurasDev\\Media\\fonts\\courbd.ttf", 14,"NONE");
DataFrame.text:SetTextColor(1,1,1,1);
DataFrame.text:SetJustifyH("LEFT");

SSA.DataFrame = DataFrame;
_G["SSA_DataFrame"] = DataFrame;

-------------------------------
--- User Notification Frame ---
-------------------------------
local AlertFrame = CreateFrame("Frame","AlertFrame",UIParent)

AlertFrame:SetBackdrop(SSA.BackdropFrm);
AlertFrame:SetBackdropColor(0,0,0,0.8)
AlertFrame:SetBackdropBorderColor(0,0,0);
AlertFrame:SetPoint("CENTER",UIParent,"CENTER",0,250);
AlertFrame:Hide();

AlertFrame.header = CreateFrame("Frame",nil,AlertFrame);
AlertFrame.header:SetWidth(AlertFrame.header:GetParent():GetWidth() - 20);
AlertFrame.header:SetHeight(30);

AlertFrame.header.text = AlertFrame.header:CreateFontString(nil, "MEDIUM", "GameFontHighlightLarge");
--[[AlertFrame.header.text:SetWidth(280);
AlertFrame.header.text:SetHeight(380);]]
AlertFrame.header.text:SetPoint("TOP",AlertFrame,"TOP",0,-10);
AlertFrame.header.text:SetFont("Interface\\addons\\ShamanAuras\\Media\\fonts\\ABF.ttf", 16);
AlertFrame.header.text:SetTextColor(1,0.82,0,1);
AlertFrame.header.text:SetJustifyH("LEFT");
AlertFrame.header.text:SetJustifyV("TOP");
AlertFrame.header.text:SetText("Sweetsour's Shaman Auras");

--[[AlertFrame.footer.text = AlertFrame.header:CreateFontString(nil, "MEDIUM", "GameFontHighlightLarge");
AlertFrame.footer.text:SetPoint("TOP",AlertFrame,"TOP",0,-10);
AlertFrame.footer.text:SetFont("Interface\\addons\\ShamanAuras\\Media\\fonts\\ABF.ttf", 16);
AlertFrame.footer.text:SetTextColor(1,0.82,0,1);
AlertFrame.footer.text:SetJustifyH("LEFT");
AlertFrame.footer.text:SetJustifyV("TOP");]]

AlertFrame.inner = CreateFrame("Frame",nil,AlertFrame);
AlertFrame.inner:SetPoint("TOP",AlertFrame,"TOP",0,-40);
AlertFrame.inner:Show();

AlertFrame.inner.text = AlertFrame.inner:CreateFontString(nil, "MEDIUM", "GameFontHighlightLarge");
AlertFrame.inner.text:CanWordWrap();
--[[AlertFrame.inner.text:SetWidth(280);
AlertFrame.inner.text:SetHeight(380);]]
--AlertFrame.inner.text:SetAllPoints(AlertFrame.inner);
AlertFrame.inner.text:SetFont("Interface\\addons\\ShamanAuras\\Media\\fonts\\ABF.ttf", 13);
AlertFrame.inner.text:SetTextColor(1,0.82,0,1);
AlertFrame.inner.text:SetJustifyV("TOP");

AlertFrame.inner.texture = AlertFrame.inner:CreateTexture(nil,"BACKGROUND");
AlertFrame.inner.texture:SetAllPoints(AlertFrame.inner);

local function CreateAlert(img,text,width,height,xDiff,yDiff,xOffset,yOffset,justify)
	AlertFrame:SetWidth(width);
	AlertFrame:SetHeight(height);

	AlertFrame.inner:SetWidth(width-xDiff);
	AlertFrame.inner:SetHeight(height-yDiff);
	AlertFrame.inner.text:SetPoint("TOP",AlertFrame,"TOP",xOffset,yOffset);
	AlertFrame.inner.text:SetJustifyH(justify);
	
	if (text) then
		AlertFrame.inner.text:SetText(text);
	end

	if (img) then
		AlertFrame.inner.texture:SetTexture(img);
	end
end

function Auras:CurText(name)
	return SSA[name].text:GetText() or '';
end

local Frame = CreateFrame("Frame");
local UpdateFrame = CreateFrame("Frame");
		
-- Frame Tables
local CDFrame = {
	[1] = {
	},
	[2] = {
	},
	[3] = {
	}
}
SSA.isEoE = false;
SSA.spec = nil;
local spec = nil;
SSA.ChargeCDFrame = {
	[1] = {
	},
	[2] = {
	},
	[3] = {
	}
}

function Auras:GetMaelstromBarObj(curSpec)
	if (curSpec == 1) then
		return SSA.MaelstromBarEle,Auras.db.char.triggers.ele.maelstrom;
	elseif (curSpec == 2) then
		return SSA.MaelstromBarEnh,Auras.db.char.triggers.enh.maelstrom;
	end
end

-- Check if the current target is an enemy
local function IsEnemyTarget()
	if (UnitExists('target') and not UnitIsFriend('target','player') and not UnitIsDead('target')) then
		return true;
	else
		return false;
	end
end

-------------------------------------------------------------------------------------------------------
----- Global Functions
-------------------------------------------------------------------------------------------------------

-- Check Current Class
function Auras:CharacterCheck(curSpec)
	local _,_,classIndex = UnitClass('player');
	local spec = GetSpecialization();
	
	if ((curSpec == spec and classIndex == 7) or (curSpec == 0 and classIndex == 7)) then
		return true;
	else
		return false;
	end
end

-- Retrieve Spell Info Name
function Auras:GetSpellName(spellID)
	local name = GetSpellInfo(spellID);
	return name;
end

-- Set the Maelstrom Bar's alpha based on whether the target is an enemy and if the player is in combat
function Auras:MaelstromAlpha()
	--[[local spec = SSA.spec;
	if ((spec == 1 or spec == 2) and not SSA.IsMovingAuras) then
		local MaelstromBar = Auras:GetMaelstromBarObj(spec);
		if (Auras:ClassCheck()) then
			if (IsEnemyTarget()) then
				--MaelstromBar:Show();
				MaelstromBar:SetAlpha(1);
				--MaelstromBar.Elapsed = 0;
				if (not UnitAffectingCombat('player')) then
					MaelstromBar:SetAlpha(0.5);
				else
					MaelstromBar:SetAlpha(1);
				end
			else
				if (not UnitAffectingCombat('player')) then
					MaelstromBar:SetAlpha(0);
				end
			end
		else
			MaelstromBar:SetAlpha(0);
		end
	end]]
end

-- Show/Hide aura icons based on the current spec
function Auras:ToggleAuraIcons(curSpec)
	for i=1,3 do
		for spellID in pairs(spellObj[i]) do
			local name = spellObj[i][spellID]:GetName();

			if (spellObj[i][spellID]) then
				if (i == curSpec and (Auras.db.char.aura[i][name])) then
					if (SSA[name].glow) then
						SSA[name].glow:Show();
					end
					
					if (SSA[name].Charges) then
						SSA[name].Charges:Show();
					end
					
					spellObj[i][spellID]:Show();
				else
					if (SSA[name].glow) then
						SSA[name].glow:Hide();
					end
					if (SSA[name.."Charges"]) then
						SSA[name.."Charges"]:Hide();
					end
					spellObj[i][spellID]:Hide();
				end
			end
		end
	--[[	for j=1,getn(miscObj[i]) do
			if (i == curSpec) then
				if (miscObj[i][j]:GetName() == "MaelstromBarEnh" or miscObj[i][j]:GetName() == "MaelstromBarEle") then
					--Auras:MaelstromAlpha();
				else
					miscObj[i][j]:Show();
				end
			else
				if (miscObj[i][j]:GetName() == "MaelstromBarEnh" or miscObj[i][j]:GetName() == "MaelstromBarEle") then
					miscObj[i][j]:SetAlpha(0);
				else
					miscObj[i][j]:Hide();
				end
			end
		end]]
	end
end

-- Enable or Disable the Tidal Wave's flashing animation when no Tidal Wave buff isn't active.
function Auras:UpdateTidalWaveBar(visible,color,isPlay,value)
	--[[local spec,TidalWavesBar = SSA.spec,SSA.TidalWavesBar;
	TidalWavesBar:SetStatusBarColor(color[1],color[2],color[3]);
	TidalWavesBar:SetValue(value);
	
	if (not TidalWavesBar:IsShown() and spec == 3) then
		TidalWavesBar:Show();
	end
	if (isPlay) then
		TidalWavesBar.Flash:Play();
	else
		TidalWavesBar.Flash:Stop();
		TidalWavesBar:SetAlpha(1);
	end]]
	
end

-------------------------------------------------------------------------------------------------------
----- Local Functions
-------------------------------------------------------------------------------------------------------

function Auras:AdjustIconDisplay(self,r,g,b,a)
	--if (SSA.spec ~= 2) then
	self.texture:SetVertexColor(r,g,b,a);
	if (self.CD) then
		self.CD.text:SetAlpha(a);
	end
	if (SSA[self:GetName()].glow) then
		SSA[self:GetName()]:SetAlpha(a);
	end
	if (self.Charges) then
		self.Charges.text:SetAlpha(a);
	end
	--end
end

local function AlterTexture(texture,bool,alpha)
	texture:SetDesaturated(bool);
	texture:SetAlpha(alpha);
end

-- Retrieve object by SpellID
local function GetObject(spellID)
	if (spellObj[spec][spellID]) then
		return spellObj[spec][spellID];
	elseif (totemObj[spec][spellID]) then
		return totemObj[spec][spellID]
	elseif (totemObj[0][spellID]) then
		return totemObj[0][spellID];
	else
		return nil;
	end
end

-- Retrieve Specialization Name
local function GetSpecName(spec)
	if (spec == 1) then
		return "Ele";
	elseif (spec == 2) then
		return "Enh";
	elseif (spec == 3) then
		return "Res";
	end
end

-- Return data about the player and their target
local function GetTargetInfo()
	return UnitExists('target'),UnitAffectingCombat('player'),UnitIsFriend('target','player'),UnitIsDead('target')
end

-- Return the type of player power being used
local function GetPowerInfo(powerType)
	if (powerType == "Maelstrom") then
		local playerPower,maxPower = UnitPower('player',11),UnitPowerMax('player',11);
		
		return playerPower,maxPower;
	elseif (powerType == "Icefury") then
		--local name = GetSpellInfo(210714);
		local _,_,_,count = UnitBuff('player',Auras:GetSpellName(210714));

		return count or 0;
	end
end

-- Aura Group Builder
local function InitializeGroup(group,width,height,point,relativeTo,relativePoint,x,y,spec,name)
	if (width ~= nil) then
		group:SetWidth(width);
		group:SetHeight(height);
	end
	
	group:EnableMouse(false);
	group:SetMovable(false);
	group:RegisterForDrag("LeftButton");
	group:SetPoint(point,(SSA[relativeTo] or UIParent),relativePoint,x,y)
	if (not Auras.db.char.aura[spec][group:GetName()] or not Auras:CharacterCheck(0)) then
		group:Hide();
	end
end

-- Initialize min/max values of a status bar
local function InitializeStatusBar(statusbar,minVal,maxVal,curVal,textVal,width,height)
	if (statusbar) then
		--SSA.ErrorFrame.text:SetText(Auras:CurText(ErrorFrame).."Status Bar: "..tostring(statusbar:GetName()).."\n")
		if (minVal) then
			statusbar:SetMinMaxValues(minVal,maxVal);
			statusbar:SetValue(curVal or 0);
		end

		if (width) then
			--statusbar:SetWidth(width);
			statusbar:SetHeight(height);
		end
		if (textVal) then
			statusbar.text:SetText(textVal);
		end
	end
end

function Auras:AdjustFont(self,font,size,flag)
	self:SetFont(font,size,flag);
end

function Auras:ToggleCombatStateOpacity(self,spec,isCombat)
	if (isCombat) then
		self:SetAlpha(1);
	else
		self:SetAlpha(Auras.db.char.triggers[spec].OoCAlpha);
	end
end

-- Convert time, in seconds, to a timer string
function Auras:parseTime(timer,precision)
	if (timer ~= nil and timer > 0) then
		local m,s,ms,fs = math.floor(timer / 60),math.floor(math.fmod(timer,60)),(("%%.%df"):format(1)):format(math.fmod(timer,60),1),timer;

		if (m >= 1 and s == 0) then
			return m..":00",fs;
		else
			if (m > 0) then
				m = m..":";
				if (s < 10) then
					s = "0"..s;
				end
			else
				m = '';
				if (s < 0) then
					s = '';
				end
			end
		end
		if (precision and tonumber(s) < 60) then
			return m..ms,fs;
		else
			return m..s,fs;
		end
	else
		return 0,0;
	end
end

function Auras:AdjustAuraSize(self,spec,object)
	if (self:GetWidth() ~= Auras.db.char.layout[spec][object].width) then
		self:SetWidth(Auras.db.char.layout[spec][object].width);
	end
	
	if (self:GetHeight() ~= Auras.db.char.layout[spec][object].height) then
		self:SetHeight(Auras.db.char.layout[spec][object].height);
	end
end

function Auras:ToggleCooldownSwipe(self,arg1)
	local cooldown = _G[self:GetName()];
	if (not arg1) then
		cooldown:SetSwipeColor(0,0,0,0);
		cooldown.text:Hide();
	else
		cooldown:SetSwipeColor(1,1,1,1);
		cooldown.text:Show();
	end
	cooldown:SetDrawSwipe(arg1)
	cooldown:SetDrawEdge(arg1)
	cooldown:SetDrawBling(arg1)
end

function Auras:ExecuteCooldown(self,start,duration,isSmallAura,isHideText)
	local expires = start + duration;
	local timer = expires - GetTime();
	local remaining,seconds = Auras:parseTime(timer,false);
	local fontSize

	if (isSmallAura) then
		if (seconds > 60) then
			fontSize = 10;
		else
			fontSize = 16;
		end
	else
		if (seconds > 60) then
			fontSize = 14;
		else
			fontSize = 18;
		end
	end
	
	self.CD.text:SetFont("Interface\\addons\\ShamanAuras\\media\\fonts\\PT_Sans_Narrow.TTF",fontSize,"OUTLINE");
	
	self.CD:SetCooldown(start,duration)
	self.CD:Show();
	
	if (not isHideText) then
		self.CD.text:SetText(Auras:parseTime(timer,false));
	else
		self.CD.text:SetText('');
	end
end

-- Run the cooldown for any abilities that are currently on cooldown
--[[local function ExecuteCooldown()
	if (Auras:ClassCheck()) then
		local fontSize = 0;
		local spec = SSA.spec;

		for spellID in pairs(spells[spec]) do
			if (spellID ~= 77762) then
				local start,duration = GetSpellCooldown(spellID);
				if (start and start == 0 and spells[spec][spellID] and not ignoreSpells[spec][spellID]) then
					ToggleCooldownSwipe(SSA[spellObj[spec][spellID]:GetName()].CD,false);
				else
					if ((SSA.isEoE and spells[spec][spellID] and (SSA.chargedSpells[SSA.spec][spellID] or SSA.chargedSpells[SSA.spec][spellID])) or spellID == 201897 or ignoreSpells[spec][spellID]) then
						-- Do Nothing
					else
						if ((duration or 0) > 2 and spells[spec][spellID] and not ignoreSpells[spellID]) then
							local CDFrame = SSA[spellObj[spec][spellID]:GetName()].CD;

							CDFrame:SetCooldown(start,duration);
							CDFrame:Show()
							ToggleCooldownSwipe(CDFrame,true);
							CDFrame:SetScript("OnUpdate", function(self)
								local PlayerGUID = UnitGUID('player');
								local expires = start + duration;
								local timer = expires - GetTime();
								local remaining,seconds = Auras:parseTime(timer,false);

								if (smallSpells[spellID]) then
									if (seconds > 60) then
										fontSize = 11;
									else
										fontSize = 16;
									end
								else
									if (seconds > 60) then
										fontSize = 14;
									else
										fontSize = 18;
									end
								end
								
								if (spellID ~= 188838) then
									if ((seconds or 0) > 0.1) then
										self.text:SetFont("Interface\\addons\\ShamanAuras\\media\\fonts\\PT_Sans_Narrow.TTF", fontSize,"OUTLINE");
										self.text:SetText(Auras:parseTime(timer,false));
									else
										ToggleCooldownSwipe(self,false);
										self.text:SetText('');
										self:SetScript("OnUpdate",nil);
									end
								end
							end);
						end
					end
				end
			else
				print("Is Lava Burst");
			end
		end
	end
end]]

-- Return the number of charges an ability currently has by spellID
local function SpellCharges(spellid)
	local charges,maxcharges = GetSpellCharges(spellid);
	local isMaxCharge = false;
	
	if (charges == maxcharges) then
		isMaxCharge = true;
	end
	
	if ((charges or 0) > 0) then
		return charges,isMaxCharge;
	else
		return nil,false;
	end
end

local function TotemMasteryCheck()
	local spec = SSA.spec;
	local isEle = false;
	local isLearned = select(4,GetTalentInfo(1,3,1));
	local isTotem = false;
	local isRefresh = false;
	local isBuff = false; 
	local buff = UnitBuff('player',Auras:GetSpellName(202192));
	local canAttack = UnitCanAttack('player','target');
	
	if (not buff) then
		isBuff = true;
	end
	local remaining
	if (spec == 1) then
		isEle = true;
	end
	for i=1,5 do
		if (select(2,GetTotemInfo(i)) == "Totem Mastery") then
			isTotem = true;
			remaining = (select(3,GetTotemInfo(i)) + select(4,GetTotemInfo(i))) - GetTime();
			break;
		end
	end
	
	if (remaining and remaining <= Auras.db.char.triggers.ele.totemMastery) then
		isRefresh = true;
	end
	--SSA.ErrorFrame.text:SetText('');
	--SSA.ErrorFrame.text:SetText(Auras:CurText().."isTotem: "..tostring(isTotem).."\nisRefresh: "..tostring(isRefresh).."\nBuff: "..tostring(buff).."\nisEle: "..tostring(isEle).."\nisLearned: "..tostring(isLearned).."\nisEnabled: "..tostring(Auras.db.char.aura[1].TotemMastery).."\nCanAttack: "..tostring(canAttack).."\n\n")
	if ((not isTotem or isRefresh or not buff) and isEle and isLearned and Auras.db.char.aura[1].TotemMastery and canAttack) then
		--SSA.ErrorFrame.text:SetText(Auras:CurText().."TRUE");
		return true;
	else
		--SSA.ErrorFrame.text:SetText(Auras:CurText().."FALSE");
		return false;
	end

	
	--return isEle and isLearned and isNoTotem and isNoRefresh and isBuff and Auras.db.char.aura[1].TotemMastery;
end

function Auras:IsTargetEnemy()
	if (UnitExists('target') and not UnitIsFriend('target','player') and not UnitIsDead('target')) then
		return true;
	else
		return false;
	end
end

function Auras:SpellRangeCheck(self,spellID,flag)
	if (Auras:IsTargetEnemy() and flag) then
		if (IsSpellInRange(Auras:GetSpellName(spellID)) == 1) then
			self.texture:SetDesaturated(false);
			self.texture:SetVertexColor(1,1,1,1);
		else
			self.texture:SetDesaturated(true);
			self.texture:SetVertexColor(Auras.db.char.triggers.ele.OoRColor.r,Auras.db.char.triggers.ele.OoRColor.g,Auras.db.char.triggers.ele.OoRColor.b,1);
		end
	elseif (Auras:IsTargetEnemy() and not flag) then
		self.texture:SetDesaturated(true);
		self.texture:SetVertexColor(0.5,0.5,0.5,1);
	else
		self.texture:SetDesaturated(false);
		self.texture:SetVertexColor(1,1,1,1);
	end
end


-- Determine target type and appropriate set icon alpha and color
local function TargetCheck(name,alpha,isExist,isCombat,isFriend,isDead)
	local spec = SSA.spec;
	local isRange;
	for spellID in pairs(targetObj[spec]) do
		
		if (spellID == 201897) then
			--isRange = SpellRangeCheck(193786);
		else
			--isRange = SpellRangeCheck(spellID);
		end
		
		--if (not isFriend and not isDead and spellID ~= 51514) then
		if (not isFriend and not isDead) then
			if (spellID ~= 51514) then
				if (isRange == 1) then
					--[[if (resourceCheck[spec][spellID]) then
						local power
						if (spec == 1 or spec == 2) then
							power = UnitPower('player',11);
						elseif (spec == 3) then
							power = UnitPower('player',19);
						end
						
						if (power >= resourceCheck[spec][spellID]) then
							Auras:AdjustIconDisplay(spellObj[spec][spellID],1,1,1,alpha);
						else
							Auras:AdjustIconDisplay(spellObj[spec][spellID],0.5,0.5,0.5,0.5);
						end
					end]]
					if (not resourceCheck[spec][spellID]) then
						--Auras:AdjustIconDisplay(spellObj[spec][spellID],1,1,1,alpha);
					end
					--spellObj[spec][spellID].texture:SetDesaturated(false);
				else
					--Auras:AdjustIconDisplay(spellObj[spec][spellID],Auras.db.char.triggers[name].OoRColor.r,Auras.db.char.triggers[name].OoRColor.g,Auras.db.char.triggers[name].OoRColor.b,alpha);
					--spellObj[spec][spellID].texture:SetDesaturated(true);
				end
			elseif (spellID == 51514) then
				if (UnitCreatureType('target') == "humanoid" or UnitCreatureType('target') == "beast") then
					if (isRange == 1) then
						--Auras:AdjustIconDisplay(spellObj[spec][spellID],1,1,1,alpha);
					else
						--Auras:AdjustIconDisplay(spellObj[spec][spellID],Auras.db.char.triggers[name].OoRColor.r,Auras.db.char.triggers[name].OoRColor.g,Auras.db.char.triggers[name].OoRColor.b,alpha);
					end
					--spellObj[spec][spellID].texture:SetDesaturated(false);
				elseif (UnitCreatureType('target') ~= "humanoid" and UnitCreatureType('target') ~= "beast") then
					--Auras:AdjustIconDisplay(spellObj[spec][spellID],0.5,0.5,0.5,alpha);
					--spellObj[spec][spellID].texture:SetDesaturated(true);
				end
			--[[elseif (spellID == 187874) then
				if (UnitPower('player',11) >= 20) then
					SSA.ErrorFrame.text:SetText(">= 20");
					Auras:AdjustIconDisplay(spellObj[spec][spellID],1,1,1,alpha);
				else
					SSA.ErrorFrame.text:SetText("< 20");
					Auras:AdjustIconDisplay(spellObj[spec][spellID],0.5,0.5,0.5,alpha);
				end]]
			end
		elseif (isFriend) then
			--Auras:AdjustIconDisplay(spellObj[spec][spellID],0.5,0.5,0.5,0.5);
		else
			--Auras:AdjustIconDisplay(spellObj[spec][spellID],1,1,1,alpha);
		end
	end
end
local function GetVersionNumber()
	return tonumber(string.sub(Auras.version,2,3));	
end
-- Toggle Button Glow Animation
function Auras:ToggleOverlayGlow(object,toggle,enemyCheck)

	if (enemyCheck and not UnitIsFriend('target','player')) then
		if (toggle) then
			LibStub("LibButtonGlow-1.0").ShowOverlayGlow(object);
		else
			LibStub("LibButtonGlow-1.0").HideOverlayGlow(object);
		end
	else
		if (toggle) then
			LibStub("LibButtonGlow-1.0").ShowOverlayGlow(object);
		else
			LibStub("LibButtonGlow-1.0").HideOverlayGlow(object);
		end
	end
end

-- Event: ADDON_LOADED
function Auras:OnInitialize()
	local defaults = {
		char = {
			version = nil,
			isEleFirst = true,
			isEnhFirst = true,
			isResFirst = true,
			isMoveGrid = true,
			cooldowns = {},
			info = {
				totems = {
					eShield = {
					},
					cBurst = {
						absorb = 0;
					}
				}
			},
			layout = {
				[1] = {
					primary = {
						top = {
							icon = 32,
							spacing = 50,
							charges = 13.5,
						},
						bottom = {
							icon = 32,
							spacing = 50,
							charges = 13.5,
						},
					},
					secondary = {
						left = {
							icon = 25,
							spacing = 30,
							charges = 13.5,
						},
						right = {
							icon = 25,
							spacing = 30,
							charges = 13.5,
						},
					},
					maelstromBar = {
						isAdjustable = false,
						width = 260,
						height = 21,
					},
					icefuryBar = {
						isAdjustable = false,
						width = 260,
						height = 21,
					},
				},
				[2] = {
					primary = {
						top = {
							icon = 32,
							spacing = 50,
							charges = 13.5,
						},
						bottom = {
							icon = 32,
							spacing = 50,
							charges = 13.5,
						},
					},
					secondary = {
						left = {
							icon = 25,
							spacing = 30,
							charges = 13.5,
						},
						right = {
							icon = 25,
							spacing = 30,
							charges = 13.5,
						},
					},
					maelstromBar = {
						isAdjustable = false,
						width = 260,
						height = 21,
					},
				},
				[3] = {
					primary = {
						top = {
							icon = 32,
							spacing = 50,
							charges = 13.5,
						},
						bottom = {
							icon = 32,
							spacing = 50,
							charges = 13.5,
						},
					},
					secondary = {
						left = {
							icon = 25,
							spacing = 30,
							charges = 13.5,
						},
						right = {
							icon = 25,
							spacing = 30,
							charges = 13.5,
						},
					},
					earthenShieldBar = {
						isAdjustable = false,
						width = 260,
						height = 21,
					},
					tidalWavesBar = {
						emptyColor = {
							r = 1,
							g = 0,
							b = 0,
							a = 1,
						},
						isAdjustable = false,
						width = 225,
						height = 7,
					},
				},
				default = {
					primary = {
						top = {
							icon = 32,
							spacing = 50,
							charges = 13.5,
						},
						bottom = {
							icon = 32,
							spacing = 50,
							charges = 13.5,
						},
					},
					secondary = {
						left = {
							icon = 25,
							spacing = 30,
							charges = 13.5,
						},
						right = {
							icon = 25,
							spacing = 30,
							charges = 13.5,
						},
					},
					LargeBar = {
						width = 260,
						height = 21,
					},
					SmallBar = {
						width = 225,
						height = 7,
					},
				},
			},
			triggers = {
				gridPreview = false,
				gridColor = {
					r = 0,
					g = 0,
					b = 0,
					a = 1,
				},
				axisColor = {
					r = 1,
					g = 0,
					b = 0,
					a = 1,
				},
				ele = {
					MaelstromAnim = true,
					maelstrom = 90,
					flameShock = 10,
					totemMastery = 15,
					OoCAlpha = 0.5,
					OoRColor = {
						r = 1,
						g = 0,
						b = 0,
						a = 1,
					}
				},
				enh = {
					MaelstromAnim = true,
					boulderfist = 5,
					maelstrom = 130,
					flametongue = 5,
					frostbrand = 5,
					OoCAlpha = 0.5,
					OoRColor = {
						r = 1,
						g = 0,
						b = 0,
						a = 1,
					}
				},
				res = {
					OoCAlpha = 0.5,
					cloudburst = 300000,
					flameShock = 10,
					OoRColor = {
						r = 1,
						g = 0,
						b = 0,
						a = 1,
					},
					animTidalWaves = true,
				},
				default = {
					gridPreview = false,
					gridColor = {
						r = 0,
						g = 0,
						b = 0,
						a = 1,
					},
					axisColor = {
						r = 1,
						g = 0,
						b = 0,
						a = 1,
					},
					ele = {
						MaelstromAnim = true,
						maelstrom = 90,
						flameShock = 10,
						totemMastery = 15,
						OoCAlpha = 0.5,
						OoRColor = {
							r = 1,
							g = 0,
							b = 0,
							a = 1,
						},
					},
					enh = {
						MaelstromAnim = true,
						maelstrom = 130,
						boulderfist = 5,
						flametongue = 5,
						frostbrand = 5,
						OoCAlpha = 0.5,
						OoRColor = {
							r = 1,
							g = 0,
							b = 0,
							a = 1,
						}
					},
					res = {
						OoCAlpha = 0.5,
						cloudburst = 300000,
						flameShock = 10,
						OoRColor = {
							r = 1,
							g = 0,
							b = 0,
							a = 1,
						},
						animTidalWaves = true,
					},
				},
			},
			aura = {
				--minor = {
					[1] = {
						AncestralGuidanceEle = true,
						AncestralGuidanceBarEle = true,
						AscendanceEle = true,
						AscendanceBarEle = true,
						AstralShiftEle = true,
						AstralShiftBarEle = true,
						AuraGroupEle = true,
						Bloodlust = true,
						BloodlustBarEle = true,
						BuffTimerBarGrpEle = true,
						CleanseSpiritEle = true,
						EarthElemental = true,
						EarthElementalBar = true,
						EarthgrabTotemEle = true,
						EarthgrabTotemBarEle = true,
						Earthquake = true,
						EarthShock = true,
						EarthShockGlow = true,
						ElementalBlast = true,
						ElementalBlastCritBar = true,
						ElementalBlastHasteBar = true,
						ElementalBlastMasteryBar = true,
						ElementalMastery = true,
						ElementalMasteryBar = true,
						FireElemental = true,
						FireElementalBar = true,
						FlameShock = true,
						FlameShockGlow = true,
						FrostShock = true,
						GustWindEle = true,
						HeroismBarEle = true,
						HexEle = true,
						HexBarEle = true,
						Icefury = true,
						IcefuryBar = true,
						LargeIconGrpBotEle = true,
						LargeIconGrpTopEle = true,
						LavaBurstEle = true,
						LavaBurstEleGlow = true,
						LavaBurstEleCharges = true,
						LavaSurgeEle = true,
						--LavaSurgeBar = true,
						LightningSurgeTotemEle = true,
						LightningSurgeTotemBarEle = true,
						LiquidMagmaTotem = true,
						LiquidMagmaTotemBar = true,
						MaelstromBarEle = true,
						MainTimerBarGrpEle = true,
						SmallIconGrpLeftEle = true,
						SmallIconGrpRightEle = true,
						StormElemental = true,
						StormElementalBar = true,
						Stormkeeper = true,
						StormkeeperChargeGrp = true,
						TimeWarpBarEle = true,
						Thunderstorm = true,
						TotemGroupEle = true,
						TotemMastery = true,
						TotemMasteryTexture = true,
						UtilTimerBarGrpEle = true,
						VoodooTotemEle = true,
						VoodooTotemBarEle = true,
						WindRushTotemEle = true,
						WindRushTotemBarEle = true,
						WindShearEle = true
					},
					[2] = {
						AscendanceEnh = true,
						AscendanceBarEnh = true,
						AstralShiftEnh = true,
						AstralShiftBarEnh = true,
						AuraGroupEnh = true,
						BloodlustEnh = true,
						BloodlustBarEnh = true,
						Boulderfist = true,
						BoulderfistBar = true,
						BoulderfistGlow = true,
						BoulderfistCharges = true,
						BuffTimerBarGrpEnh = true,
						CleanseSpiritEnh = true,
						CrashLightning = true,
						CrashLightningBar = true,
						CrashLightningGlow = true,
						DoomWinds = true,
						DoomWindsTex = true,
						EarthenSpike = true,
						EarthenSpikeBar = true,
						EarthgrabTotemEnh = true,
						EarthgrabTotemBarEnh = true,
						FeralLunge = true,
						FeralSpirit = true,
						FeralSpiritBar = true,
						Flametongue = true,
						FlametongueBar = true,
						FlametongueGlow = true,
						Frostbrand = true,
						FrostbrandBar = true,
						FrostbrandGlow = true,
						HeroismBarEng = true,
						HexEnh = true,
						HexBarEnh = true,
						LargeIconGrpBotEnh = true,
						LargeIconGrpTopEnh = true,
						LavaLash = true,
						LightningSurgeTotemEnh = true,
						LightningSurgeTotemBarEnh = true,
						MaelstromBarEnh = true,
						MainTimerBarGrpEnh = true,
						Rainfall = true,
						SmallIconGrpLeftEnh = true,
						SmallIconGrpRightEnh = true,
						SpiritWalk = true,
						SpiritWalkBar = true,
						Stormstrike = true,
						StormstrikeChargeGrp = true,
						StormstrikeChargesText = false,
						StormstrikeGlow = true,
						Sundering = true,
						TimeWarpBarEnh = true,
						UtilTimerBarGrpEnh = true,
						VoodooTotemEnh = true,
						VoodooTotemBarEnh = true,
						WindRushTotemEnh = true,
						WindRushTotemBarEnh = true,
						WindShearEnh = true,
						Windsong = true,
						WindsongBar = true,
						WindsongGlow = true,
					},
					[3] = {
						AncestralGuidanceRes = true,
						AncestralGuidanceBarRes = true,
						AncestralProtectionTotem = true,
						AncestralProtectionTotemBar = true,
						AscendanceRes = true,
						AscendanceBarRes = true,
						AstralShiftRes = true,
						AstralShiftBarRes = true,
						AuraGroupRes = true,
						--Bloodlust = true,
						BloodlustBarRes = true,
						BuffTimerBarGrpRes = true,
						Cloudburst = true,
						CloudburstAbsorbBar = true,
						CloudburstTotem = true,
						CloudburstTotemBar = true,
						EarthenShieldTotem = true,
						EarthenShieldTotemBar = true,
						EarthgrabTotemRes = true,
						EarthgrabTotemBarRes = true,
						FlameShockRes = true,
						FlameshockResGlow = true,
						GiftOfQueen = true,
						GustWindRes = true,
						HealingRain = true,
						HealingStreamTotem = true,
						HealingStreamTotemBar = true,
						HealingStreamTotemBarOne = true,
						HealingStreamTotemBarTwo = true,
						HealingStreamCharges = true,
						HealingTideTotem = true,
						HealingTideTotemBar = true,
						HeroismBarRes = true,
						HexRes = true,
						HexBarRes = true,
						LargeIconGrpBotRes = true,
						LargeIconGrpTopRes = true,
						LavaBurstRes = true,
						LavaBurstResGlow = true,
						LavaBurstResCharges = true,
						LavaSurgeRes = true,
						--LavaSurgeBarRes = true,
						LightningSurgeTotemRes = true,
						LightningSurgeTotemBarRes = true,
						MainTimerBarGrpRes = true,
						PurifySpirit = true,
						Riptide = true,
						RiptideCharge = true,
						SmallIconGrpLeftRes = true,
						SmallIconGrpRightRes = true,
						SpiritLinkTotem = true,
						SpiritLinkTotemBar = true,
						SpiritwalkersGrace = true,
						SpiritwalkersGraceBar = true,
						TidalWaves = true,
						TidalWavesBar = true,
						TidalWavesCharges = true,
						Undulation = true,
						UnleashLife = true,
						UnleashLifeBar = true,
						UtilTimerBarGrpRes = true,
						VoodooTotemRes = true,
						VoodooTotemBarRes = true,
						Wellspring = true,
						WindRushTotemRes = true,
						WindRushTotemBarRes = true,
						WindShearRes = true,
					},
				--},
			},
			frames = {
				timerbars = {
					buff = {
						[1] = true,
						[2] = true,
						[3] = true,
					},
					main = {
						[1] = true,
						[2] = true,
						[3] = true,
					},
					util = {
						[1] = true,
						[2] = true,
						[3] = true,
					},
				},
				eleGrp = {
					enabled = true,
					AuraGroupEle = {
						point = "CENTER",
						relativeTo = nil,
						relativePoint = "CENTER",
						x = 0,
						y = 0,
						width = (GetScreenWidth() - 500),
						height = (GetScreenHeight() - 250),
					},
					LargeIconGrpTopEle = {
						point = "CENTER",
						relativeTo = "AuraGroupEle",
						relativePoint = "CENTER",
						x = 0,
						y = -180,
						width = 250,
						height = 50,
					},
					LargeIconGrpBotEle = {
						point = "CENTER",
						relativeTo = "AuraGroupEle",
						relativePoint = "CENTER",
						x = 0,
						y = -225,
						width = 250,
						height = 50,
					},
					SmallIconGrpLeftEle = {
						point = "CENTER",
						relativeTo = "AuraGroupEle",
						relativePoint = "CENTER",
						x = -175,
						y = -170,
						width = 35,
						height = 160,
					},
					SmallIconGrpRightEle = {
						point = "CENTER",
						relativeTo = "AuraGroupEle",
						relativePoint = "CENTER",
						x = 175,
						y = -170,
						width = 35,
						height = 160,
					},
					BuffTimerBarGrpEle = {
						point = "LEFT",
						relativeTo = "AuraGroupEle",
						relativePoint = "CENTER",
						x = 190,
						y = -125,
						width = 115,
						height = 180,
					},
					MainTimerBarGrpEle = {
						point = "RIGHT",
						relativeTo = "AuraGroupEle",
						relativePoint = "CENTER",
						x = -190,
						y = -125,
						width = 90,
						height = 180,
					},
					UtilTimerBarGrpEle = {
						point = "RIGHT",
						relativeTo = "AuraGroupEle",
						relativePoint = "CENTER",
						x = -190,
						y = -125,
						width = 70,
						height = 180,
					},
					MaelstromBarEle = {
						point = "CENTER",
						relativeTo = "AuraGroupEle",
						relativePoint = "CENTER",
						x = 0,
						y = -139,
						width = nil,
						height = nil,
						alpha = 0.5,
					},
					IcefuryBar = {
						point = "CENTER",
						relativeTo = "AuraGroupEle",
						relativePoint = "CENTER",
						x = 0,
						y = -110,
						width = nil,
						height = nil,
						alpha = 0.9,
					},
					TotemGroupEle = {
						point = "CENTER",
						relativeTo = "AuraGroupEle",
						relativePoint = "CENTER",
						x = -200,
						y = 0,
						width = 200,
						height = 50,
						BackdropColor = {
							r = 0.15,
							g = 0.15,
							b = 0.15,
							a = 0.6,
						}
					},
					TotemMastery = {
						point = "CENTER",
						relativeTo = "AuraGroupEle",
						relativePoint = "CENTER",
						x = 0,
						y = -210,
						width = nil,
						height = nil,
					},
					StormkeeperChargeGrp = {
						point = "CENTER",
						relativeTo = "AuraGroupEle",
						relativePoint = "CENTER",
						x = 0,
						y = -110,
						width = 260,
						height = 50,
					}
				},
				enhGrp = {
					enabled = true,
					AuraGroupEnh = {
						point = "CENTER",
						relativeTo = nil,
						relativePoint = "CENTER",
						x = 0,
						y = 0,
						width = (GetScreenWidth() - 500),
						height = (GetScreenHeight() - 250),
					},
					LargeIconGrpTopEnh = {
						point = "CENTER",
						relativeTo = "AuraGroupEnh",
						relativePoint = "CENTER",
						x = 0,
						y = -180,
						width = 250,
						height = 50,
					},
					LargeIconGrpBotEnh = {
						point = "CENTER",
						relativeTo = "AuraGroupEnh",
						relativePoint = "CENTER",
						x = 0,
						y = -225,
						width = 250,
						height = 50,
					},
					SmallIconGrpLeftEnh = {
						point = "CENTER",
						relativeTo = "AuraGroupEnh",
						relativePoint = "CENTER",
						x = -175,
						y = -170,
						width = 35,
						height = 160,
					},
					SmallIconGrpRightEnh = {
						point = "CENTER",
						relativeTo = "AuraGroupEnh",
						relativePoint = "CENTER",
						x = 175,
						y = -170,
						width = 35,
						height = 160,
					},
					BuffTimerBarGrpEnh = {
						point = "LEFT",
						relativeTo = "AuraGroupEnh",
						relativePoint = "CENTER",
						x = 190,
						y = -125,
						width = 131,
						height = 180,
					},
					MainTimerBarGrpEnh = {
						point = "RIGHT",
						relativeTo = "AuraGroupEnh",
						relativePoint = "CENTER",
						x = -190,
						y = -125,
						width = 131,
						height = 180,
					},
					UtilTimerBarGrpEnh = {
						point = "RIGHT",
						relativeTo = "AuraGroupEnh",
						relativePoint = "CENTER",
						x = -190,
						y = -125,
						width = 47,
						height = 180,
					},
					MaelstromBarEnh = {
						point = "CENTER",
						relativeTo = "AuraGroupEnh",
						relativePoint = "CENTER",
						x = 0,
						y = -139,
						width = nil,
						height = nil,
					},
					StormstrikeChargeGrp = {
						point = "CENTER",
						relativeTo = "AuraGroupEnh",
						relativePoint = "CENTER",
						x = 0,
						y = -100,
						width = 260,
						height = 50,
					},
					DoomWindsTex = {
						point = "CENTER",
						relativeTo = "AuraGroupEnh",
						relativePoint = "CENTER",
						x = -150,
						y = 0,
						width = 125,
						height = 240,
					},
				},
				resGrp = {
					enabled = true,
					AuraGroupRes = {
						point = "CENTER",
						relativeTo = nil,
						relativePoint = "CENTER",
						x = 0,
						y = 0,
						width = (GetScreenWidth() - 500),
						height = (GetScreenHeight() - 250),
					},
					LargeIconGrpTopRes = {
						point = "CENTER",
						relativeTo = "AuraGroupRes",
						relativePoint = "CENTER",
						x = 0,
						y = -180,
						width = 250,
						height = 50,
					},
					LargeIconGrpBotRes = {
						point = "CENTER",
						relativeTo = "AuraGroupRes",
						relativePoint = "CENTER",
						x = 0,
						y = -225,
						width = 250,
						height = 50,
					},
					SmallIconGrpLeftRes = {
						point = "CENTER",
						relativeTo = "AuraGroupRes",
						relativePoint = "CENTER",
						x = -175,
						y = -170,
						width = 35,
						height = 160,
					},
					SmallIconGrpRightRes = {
						point = "CENTER",
						relativeTo = "AuraGroupRes",
						relativePoint = "CENTER",
						x = 175,
						y = -170,
						width = 35,
						height = 160,
					},
					BuffTimerBarGrpRes = {
						point = "LEFT",
						relativeTo = "AuraGroupRes",
						relativePoint = "CENTER",
						x = 190,
						y = -125,
						width = 131,
						height = 180,
					},
					MainTimerBarGrpRes = {
						point = "RIGHT",
						relativeTo = "AuraGroupRes",
						relativePoint = "CENTER",
						x = -190,
						y = -125,
						width = 105,
						height = 180,
					},
					UtilTimerBarGrpRes = {
						point = "RIGHT",
						relativeTo = "AuraGroupRes",
						relativePoint = "CENTER",
						x = -190,
						y = -125,
						width = 47,
						height = 180,
					},
					EarthenShieldTotemBar = {
						point = "CENTER",
						relativeTo = "AuraGroupRes",
						relativePoint = "CENTER",
						x = 0,
						y = -139,
						width = nil,
						height = nil,
					},
					TidalWavesBar = {
						point = "CENTER",
						relativeTo = "AuraGroupRes",
						relativePoint = "CENTER",
						x = 0,
						y = -202,
						width = nil,
						height = nil,
					},
					Cloudburst = {
						point = "CENTER",
						relativeTo = "AuraGroupRes",
						relativePoint = "CENTER",
						x = -200,
						y = 0,
						width = 150,
						height = 40,
						BackdropColor = {
							r = 0.15,
							g = 0.15,
							b = 0.15,
							a = 0.6,
						}
					},
					Undulation = {
						point = "CENTER",
						relativeTo = "AuraGroupRes",
						relativePoint = "CENTER",
						x = 0,
						y = -275,
						width = nil,
						height = nil,
					},
				},
				defaultPos = {
					eleGrp = {
						AuraGroupEle = {
							point = "CENTER",
							relativeTo = nil,
							relativePoint = "CENTER",
							x = 0,
							y = 0,
						},
						LargeIconGrpTopEle = {
							point = "CENTER",
							relativeTo = "AuraGroupEle",
							relativePoint = "CENTER",
							x = 0,
							y = -180,
						},
						LargeIconGrpBotEle = {
							point = "CENTER",
							relativeTo = "AuraGroupEle",
							relativePoint = "CENTER",
							x = 0,
							y = -225,
						},
						SmallIconGrpLeftEle = {
							point = "CENTER",
							relativeTo = "AuraGroupEle",
							relativePoint = "CENTER",
							x = -175,
							y = -170,
						},
						SmallIconGrpRightEle = {
							point = "CENTER",
							relativeTo = "AuraGroupEle",
							relativePoint = "CENTER",
							x = 175,
							y = -170,
						},
						BuffTimerBarGrpEle = {
							point = "LEFT",
							relativeTo = "AuraGroupEle",
							relativePoint = "CENTER",
							x = 190,
							y = -125,
						},
						MainTimerBarGrpEle = {
							point = "RIGHT",
							relativeTo = "AuraGroupEle",
							relativePoint = "CENTER",
							x = -190,
							y = -125,
						},
						UtilTimerBarGrpEle = {
							point = "RIGHT",
							relativeTo = "AuraGroupEle",
							relativePoint = "CENTER",
							x = -190,
							y = -125,
						},
						MaelstromBarEle = {
							point = "CENTER",
							relativeTo = "AuraGroupEle",
							relativePoint = "CENTER",
							x = 0,
							y = -139,
						},
						IcefuryBar = {
							point = "CENTER",
							relativeTo = "AuraGroupEle",
							relativePoint = "CENTER",
							x = 0,
							y = -110,
						},
						TotemMastery = {
							point = "CENTER",
							relativeTo = "AuraGroupEle",
							relativePoint = "CENTER",
							x = 0,
							y = -210,
						},
						--[[LavaSurgeEle = {
							point = "CENTER",
							relativeTo = "AuraGroupEle",
							relativePoint = "CENTER",
							x = -130,
							y = 0,
						},]]
						StormkeeperChargeGrp = {
							point = "CENTER",
							relativeTo = "AuraGroupEle",
							relativePoint = "CENTER",
							x = 0,
							y = -110,
						}
					},
					enhGrp = {
						AuraGroupEnh = {
							point = "CENTER",
							relativeTo = nil,
							relativePoint = "CENTER",
							x = 0,
							y = 0,
						},
						LargeIconGrpTopEnh = {
							point = "CENTER",
							relativeTo = "AuraGroupEnh",
							relativePoint = "CENTER",
							x = 0,
							y = -180,
						},
						LargeIconGrpBotEnh = {
							point = "CENTER",
							relativeTo = "AuraGroupEnh",
							relativePoint = "CENTER",
							x = 0,
							y = -225,
						},
						SmallIconGrpLeftEnh = {
							point = "CENTER",
							relativeTo = "AuraGroupEnh",
							relativePoint = "CENTER",
							x = -175,
							y = -170,
						},
						SmallIconGrpRightEnh = {
							point = "CENTER",
							relativeTo = "AuraGroupEnh",
							relativePoint = "CENTER",
							x = 175,
							y = -170,
						},
						BuffTimerBarGrpEnh = {
							point = "LEFT",
							relativeTo = "AuraGroupEnh",
							relativePoint = "CENTER",
							x = 190,
							y = -125,
						},
						MainTimerBarGrpEnh = {
							point = "RIGHT",
							relativeTo = "AuraGroupEnh",
							relativePoint = "CENTER",
							x = -190,
							y = -125,
						},
						UtilTimerBarGrpEnh = {
							point = "RIGHT",
							relativeTo = "AuraGroupEnh",
							relativePoint = "CENTER",
							x = -190,
							y = -125,
						},
						MaelstromBarEnh = {
							point = "CENTER",
							relativeTo = "AuraGroupEnh",
							relativePoint = "CENTER",
							x = 0,
							y = -139,
						},
						StormstrikeChargeGrp = {
							point = "CENTER",
							relativeTo = "AuraGroupEnh",
							relativePoint = "CENTER",
							x = 0,
							y = -100,
						},
						DoomWindsTex = {
							point = "CENTER",
							relativeTo = "AuraGroupEnh",
							relativePoint = "CENTER",
							x = -150,
							y = 0,
						},
					},
					resGrp = {
						AuraGroupRes = {
							point = "CENTER",
							relativeTo = nil,
							relativePoint = "CENTER",
							x = 0,
							y = 0,
						},
						LargeIconGrpTopRes = {
							point = "CENTER",
							relativeTo = "AuraGroupRes",
							relativePoint = "CENTER",
							x = 0,
							y = -180,
						},
						LargeIconGrpBotRes = {
							point = "CENTER",
							relativeTo = "AuraGroupRes",
							relativePoint = "CENTER",
							x = 0,
							y = -225,
						},
						SmallIconGrpLeftRes = {
							point = "CENTER",
							relativeTo = "AuraGroupRes",
							relativePoint = "CENTER",
							x = -175,
							y = -170,
						},
						SmallIconGrpRightRes = {
							point = "CENTER",
							relativeTo = "AuraGroupRes",
							relativePoint = "CENTER",
							x = 175,
							y = -170,
						},
						BuffTimerBarGrpRes = {
							point = "LEFT",
							relativeTo = "AuraGroupRes",
							relativePoint = "CENTER",
							x = 190,
							y = -125,
						},
						MainTimerBarGrpRes = {
							point = "RIGHT",
							relativeTo = "AuraGroupRes",
							relativePoint = "CENTER",
							x = -190,
							y = -125,
						},
						UtilTimerBarGrpRes = {
							point = "RIGHT",
							relativeTo = "AuraGroupRes",
							relativePoint = "CENTER",
							x = -190,
							y = -125,
						},
						EarthenShieldTotemBar = {
							point = "CENTER",
							relativeTo = "AuraGroupRes",
							relativePoint = "CENTER",
							x = 0,
							y = -139,
						},
						TidalWavesBar = {
							point = "CENTER",
							relativeTo = "AuraGroupRes",
							relativePoint = "CENTER",
							x = 0,
							y = -202,
						},
						Cloudburst = {
							point = "CENTER",
							relativeTo = "AuraGroupRes",
							relativePoint = "CENTER",
							x = 150,
							y = 0,
						},
						Undulation = {
							point = "CENTER",
							relativeTo = "AuraGroupRes",
							relativePoint = "CENTER",
							x = 0,
							y = -275,
						},
					},
				},
			},
		}
	}
	
	local about_panel = LibStub:GetLibrary("LibAboutPanel", true)

	if about_panel then
		self.optionsFrame = about_panel.new(nil, "ShamanAuras")
	end
	
	self.db = LibStub("AceDB-3.0"):New("SSA_db",defaults);
	self:SetupOptions();
	
	
end

-- Event: PLAYER_LOGIN
function Auras:OnEnable()
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
	self:RegisterEvent("SPELL_UPDATE_COOLDOWN");
	self:RegisterEvent("ADDON_LOADED");
	self:RegisterEvent("PLAYER_LOGIN");
	self:RegisterEvent("PLAYER_ENTERING_WORLD");
	self:RegisterEvent("PLAYER_LEVEL_UP");
	self:RegisterEvent("PLAYER_REGEN_DISABLED");
	self:RegisterEvent("UNIT_POWER");
	self:RegisterEvent("PLAYER_TARGET_CHANGED");
	self:RegisterEvent("PLAYER_TALENT_UPDATE");
	--self:RegisterEvent("SPELL_UPDATE_CHARGES","ChargeCooldown");
	self:RegisterEvent("SPELL_UPDATE_USABLE");

	--InterfaceOptionsFrame:HookScript("OnShow",function(self)
		--if (not InterfaceOptionsFrame:IsMovable()) then
			
			InterfaceOptionsFrame:EnableMouse(true);
			InterfaceOptionsFrame:SetMovable(true);
			InterfaceOptionsFrame:RegisterForDrag("LeftButton");
			InterfaceOptionsFrame:SetUserPlaced(true);
			InterfaceOptionsFrame:SetScript("OnMouseDown",function(self,button)
				if (button == "LeftButton" and not self.isMoving) then
					self:StartMoving();
					self.isMoving = true;
				end
			end);
			InterfaceOptionsFrame:SetScript("OnMouseUp",function(self,button)
				if (button == "LeftButton" and self.isMoving) then
					self:StopMovingOrSizing();
					self.isMoving = false;
				end
			end);
			InterfaceOptionsFrame:HookScript("OnHide",function(self,button)
				if (self.isMoving) then
					self:StopMovingOrSizing();
					self.isMoving = false;
				end
				
				Auras.db.char.layout[1].icefuryBar.isAdjustable = false;
				Auras.db.char.layout[1].maelstromBar.isAdjustable = false;
				Auras.db.char.layout[2].maelstromBar.isAdjustable = false;
				Auras.db.char.layout[3].earthenShieldBar.isAdjustable = false;
				Auras.db.char.layout[3].tidalWavesBar.isAdjustable = false;
				
				SSA.MaelstromBarEle:SetAlpha(0);
				SSA.MaelstromBarEnh:SetAlpha(0);
				SSA.EarthenShieldTotemBar:Hide();
				SSA.TidalWavesBar:SetAlpha(0);
			end);
		--end
	--end);
	
	smallSpells = {
		[108281] = true, -- Ancestral Guidance
		[108271] = true, -- Astral Shift
		[51886]  = true, -- Cleanse Spirit
		[198103] = true, -- Earth Elemental
		[51485]  = true, -- Earthgrab Totem
		[192063] = true, -- Gust of Wind
		[51514]  = true, -- Hex (Frog)
		[210873] = true, -- Hex (Raptor)
		[211015] = true, -- Hex (Roach)
		[211010] = true, -- Hex (Snake)
		[211004] = true, -- Hex (Spider)
		[192058] = true, -- Lightning Surge Totem
		[77130]  = true, -- Purify Spirit
		[215864] = true, -- Rainfall
		[58875]  = true, -- Spirit Walk
		[79206]  = true, -- Spiritwalker's Grace
		[51490]  = true, -- Thunderstorm
		[196932] = true, -- Voodoo Totem
		[192077] = true, -- Wind Rush Totem
		[57994]  = true, -- Wind Shear
	}
	
	spells = {
		[1] = { -- Elemental
			[108281] = true, -- Ancestral Guidance
			[114050] = true, -- Ascendance
			[108271] = true, -- Astral Shift
			[2825]   = true, -- Bloodlust
			[51886]  = true, -- Cleanse Spirit
			[117014] = true, -- Elemental Blast
			[198103] = true, -- Earth Elemental
			[188616] = true, -- Earth Elemental (Normal) (SPELL_SUMMON ID)
			[118323] = true, -- Earth Elemental (Primal) (SPELL_SUMMON ID)
			[51485]  = true, -- Earthgrab Totem
			[8042]   = true, -- Earth Shock
			[208723] = true, -- Echoes of the Great Sundering
			[16166]  = true, -- Elemental Mastery
			[198067] = true, -- Fire Elemental
			[188592] = true, -- Fire Elemental (Normal) (SPELL_SUMMON ID)
			[118291] = true, -- Fire Elemental (Primal) (SPELL_SUMMON ID)
			[188389] = true, -- Flame Shock
			[196840] = true, -- Frost Shock
			[192063] = true, -- Gust of Wind
			[32182]  = true, -- Heroism
			[51514]  = true, -- Frog Hex
			[210873] = true, -- Raptor Hex
			[211004] = true, -- Spider Hex
			[211010] = true, -- Snake Hex
			[211015] = true, -- Roach Hex
			[210714] = true, -- Icefury
			[51505]  = true, -- Lava Burst
			[77762]  = true, -- Lava Surge
			[192058] = true, -- Lightning Surge Totem
			[192222] = true, -- Liquid Magma Totem
			[192249] = true, -- Storm Elemental
			[157299] = true, -- Storm Elemental (Normal) (SPELL_SUMMON ID)
			[157319] = true, -- Storm Elemental (Primal) (SPELL_SUMMON ID)
			[205495] = true, -- Stormkeeper
			[80353]  = true, -- Time Warp
			[51490]  = true, -- Thunderstorm
			[196932] = true, -- Voodoo Totem
			[192077] = true, -- Wind Rush Totem
			[57994]  = true, -- Wind Shear
		},
		[2] = { -- Enhancement
			[114051] = true, -- Ascendance
			[108271] = true, -- Astral Shift
			--[2825]   = true, -- Bloodlust
			[201897] = true, -- Boulderfist
			[218825] = true, -- Boulderfist (SPELL_AURA_APPLIED ID)
			[51886]  = true, -- Cleanse Spirit
			[187874] = true, -- Crash Lightning
			[187878] = true, -- Crash Lightning (SPELL_AURA_APPLIED ID)
			[188089] = true, -- Earthen Spike
			[51485]  = true, -- Earthgrab Totem
			[204945] = true, -- Doom Winds
			[196884] = true, -- Feral Lunge
			[51533]  = true, -- Feral Spirit
			[193796] = true, -- Flametongue
			[196834] = true, -- Frostbrand
			[51514]  = true, -- Frog Hex
			[32182]  = true, -- Heroism
			[60103]  = true, -- Lava Lash
			[210873] = true, -- Raptor Hex
			[211004] = true, -- Spider Hex
			[211010] = true, -- Snake Hex
			[211015] = true, -- Roach Hex
			[192058] = true, -- Lightning Surge Totem
			[215864] = true, -- Rainfall
			[58875]  = true, -- Spirit Walk
			[201846] = true, -- Stormbringer
			[195222] = true, -- Stormlash
			[17364]  = true, -- Stormstrike
			[197214] = true, -- Sundering
			[80353]  = true, -- Time Warp
			[196932] = true, -- Voodoo Totem
			[192077] = true, -- Wind Rush Totem
			[57994]  = true, -- Wind Shear
			[201898] = true, -- Windsong
		},
		[3] = { -- Restoration
			[108281] = true, -- Ancestral Guidance
			[207399] = true, -- Ancestral Protection Totem
			[114052] = true, -- Ascendance
			[108271] = true, -- Astral Shift
			[2825]   = true, -- Bloodlust
			[157153] = true, -- Cloudburst Totem
			[198838] = true, -- Earthen Shield Totem
			[201633] = true, -- Earthen Shield (SPELL_ABSORBED)
			[51485]  = true, -- Earthgrab Totem
			[188838] = true, -- Flame Shock
			[207778] = true, -- Gift of the Queen
			[192063] = true, -- Gust of Wind
			[73920]  = true, -- Healing Rain
			[5394]   = true, -- Healing Stream Totem
			[108280] = true, -- Healing Tide Totem
			[32182]  = true, -- Heroism
			[51514]  = true, -- Frog Hex
			[210873] = true, -- Raptor Hex
			[211004] = true, -- Spider Hex
			[211010] = true, -- Snake Hex
			[211015] = true, -- Roach Hex
			[51505]  = true, -- Lava Burst
			[77762]  = true, -- Lava Surge
			[192058] = true, -- Lightning Surge Totem
			[77130]  = true, -- Purify Spirit
			[61295]  = true, -- Riptide
			[98008]  = true, -- Spirit Link Totem
			[79206]  = true, -- Spiritwalker's Grace
			[53390]  = true, -- Tidal Waves
			[80353]  = true, -- Time Warp
			[216251] = true, -- Undulation
			[73685]  = true, -- Unleash Life
			[196932] = true, -- Voodoo Totem
			[197995] = true, -- Wellspring
			[192077] = true, -- Wind Rush Totem
			[57994]  = true, -- Wind Shear
		}
	}

	resourceCheck = {
		[1] = {
			[8042]  = 10, -- Earth Shock
			[61882] = 50, -- Earthquake
		},
		[2] = {
			[187874] = 20, -- Crash Lightning
			[196834] = 20, -- Frostbrand
			[17364]  = 40, -- Stormstrike
		},
		[3] = {
		
		},
	}
	-- Ignore certain spells
	ignoreSpells = {
		[1] = {
			[2825]   = true, -- Bloodlust
			[188616] = true, -- Earth Elemental (Normal) (SPELL_SUMMON ID)
			[118323] = true, -- Earth Elemental (Primal) (SPELL_SUMMON ID)
			[8042]   = true, -- Earth Shock
			[208723] = true, -- Echoes of the Great Sundering
			[188592] = true, -- Fire Elemental  (Normal) (SPELL_SUMMON ID)
			[118291] = true, -- Fire Elemental  (Primal) (SPELL_SUMMON ID)
			[196840] = true, -- Frost Shock
			[32182]  = true, -- Heroism
			[77762]  = true, -- Lava Surge
			[157299] = true, -- Storm Elemental (Normal) (SPELL_SUMMON ID)
			[157319] = true, -- Storm Elemental (Primal) (SPELL_SUMMON ID)
			[80353]  = true, -- Time Warp
		},
		[2] = {
			[2825]   = true, -- Bloodlust
			[218825] = true, -- Boulderfist (SPELL_AURA_APPLIED ID)
			[187878] = true, -- Crash Lightning (SPELL_AURA_APPLIED ID)
			[32182]  = true, -- Heroism
			[193786] = true, -- Rockbiter
			[201846] = true, -- Stormbringer
			[195222] = true, -- Stormlash
			[80353]  = true, -- Time Warp
		},
		[3] = {
			[207399] = true, -- Ancestral Protection Totem
			[2825]   = true, -- Bloodlust
			[201633] = true, -- Earthen Shield (SPELL_ABSORBED)
			--[188838] = true, -- Flame Shock
			[32182]  = true, -- Heroism
			[77762]  = true, -- Lava Surge
			[53390]  = true, -- Tidal Waves
			[80353]  = true, -- Time Warp
			[216251] = true, -- Undulation
		},
	}
	-- Abilities that require target check
	targetObj = {
		[1] = {
			--[51886]  = true, -- Cleanse Spirit
			[117014] = true, -- Elemental Blast
			[8042]   = true, -- Earth Shock
			[188389] = true, -- Flame Shock
			--[196840] = true, -- Frost Shock
			[51514]  = true, -- Frog Hex
			[210714] = true, -- Icefury
			--[210873] = true, -- Raptor Hex
			--[211004] = true, -- Spider Hex
			--[211010] = true, -- Snake Hex
			--[211015] = true, -- Roach Hex
			[51505]  = true, -- Lava Burst
			[57994]  = true, -- Wind Shear
		},
		[2] = {
			[201897] = true, -- Boulderfist
			--[51886]  = true, -- Cleanse Spirit
			[188089] = true, -- Earthen Spike
			[196884] = true, -- Feral Lunge
			[193796] = true, -- Flametongue
			[196834] = true, -- Frostbrand
			--[51514]  = true, -- Frog Hex
			--[210873] = true, -- Raptor Hex
			--[211004] = true, -- Spider Hex
			--[211010] = true, -- Snake Hex
			--[211015] = true, -- Roach Hex
			[17364]  = true, -- Stormstrike
			[197214] = true, -- Sundering
			[201898] = true, -- Windsong
			[57994]  = true, -- Wind Shear
		},
		[3] = {
			[188838] = true, -- Flame Shock (Restoration)
			[51514]  = true, -- Frog Hex
			--[210873] = true, -- Raptor Hex
			--[211004] = true, -- Spider Hex
			--[211010] = true, -- Snake Hex
			--[211015] = true, -- Roach Hex
			[51505]  = true, -- Lava Burst
			--[77130]  = true, -- Purify Spirit
			--[61295]  = true, -- Riptide
			--[73685]  = true, -- Unleash Life
			[57994]  = true, -- Wind Shear
		},
	}
	
	barObjIndex = {
		[114050] = "SPELL_AURA_APPLIED",	-- Ascendance (Elemental)
		[108281] = "SPELL_AURA_APPLIED",	-- Ancestral Guidance
		[108271] = "SPELL_AURA_APPLIED",	-- Astral Shift
		[2825]   = "SPELL_AURA_APPLIED",	-- Bloodlust
		[118522] = "SPELL_AURA_APPLIED",	-- Elemental Blast (Critical Strike)
		[173183] = "SPELL_AURA_APPLIED",	-- Elemental Blast (Haste)
		[173184] = "SPELL_AURA_APPLIED",	-- Elemental Blast (Mastery)
		[16166]  = "SPELL_AURA_APPLIED",	-- Elemental Mastery
		[114051] = "SPELL_AURA_APPLIED",	-- Ascendance (Enhancement)
		[108271] = "SPELL_AURA_APPLIED",	-- Astral Shift
		[58875]  = "SPELL_AURA_APPLIED",	-- Spirit Walk
		[218825] = "SPELL_AURA_APPLIED",	-- Boulderfist
		[187878] = "SPELL_AURA_APPLIED",	-- Crash Lightning
		[193796] = "SPELL_CAST_SUCCESS",	-- Flametongue
		[196834] = "SPELL_AURA_APPLIED",	-- Frostbrand
		[201898] = "SPELL_AURA_APPLIED",	-- Windsong
		[188089] = "SPELL_CAST_SUCCESS",	-- Earthen Spike
		[51514]  = "SPELL_CAST_SUCCESS",	-- Hex
		[114052] = "SPELL_AURA_APPLIED",	-- Ascendance (Restoration)
		[108281] = "SPELL_AURA_APPLIED",	-- Ancestral Guidance
		[108271] = "SPELL_AURA_APPLIED",	-- Astral Shift
		[79206]  = "SPELL_AURA_APPLIED",	-- Spiritwalker's Grace
		[73685]  = "SPELL_AURA_APPLIED",	-- Unleash Life
	}
	totemObj = {
		[1] = {
			[188616] = SSA.EarthElementalBar,
			[118323] = SSA.EarthElementalBar,
			[188592] = SSA.FireElementalBar,
			[118291] = SSA.FireElementalBar,
			[157299] = SSA.StormElementalBar,
			[157319] = SSA.StormElementalBar,
			[51485]  = SSA.EarthgrabTotemBarEle,
			[192222] = SSA.LiquidMagmaTotemBar,
			[196932] = SSA.VoodooTotemBarEle,
			[192077] = SSA.WindRushTotemBarEle,
		},
		[2] = {
			[51485]  = SSA.EarthgrabTotemBarEle,
			[192222] = SSA.LiquidMagmaTotemBar,
			[196932] = SSA.VoodooTotemBarEle,
			[192077] = SSA.WindRushTotemBarEle,
		},
		[3] = {
			[207399] = SSA.AncestralProtTotemBar,
			[157153] = SSA.CloudburstTotemBar,
			[5394]   = {
				[1] = SSA.HealingStreamTotemBarOne,
				[2] = SSA.HealingStreamTotemBarTwo,
			},
			[108280] = SSA.HealingTideTotemBar,
			[98008]  = SSA.SpiritLinkTotemBar,
			[51485]  = SSA.EarthgrabTotemBarEle,
			[192222] = SSA.LiquidMagmaTotemBar,
			[196932] = SSA.VoodooTotemBarEle,
			[192077] = SSA.WindRushTotemBarEle,
		},
	}
	barObj = {
		[1] = {
			["buff"] = {
				[114050] = SSA.AscendanceBarEle,
				[108281] = SSA.GuidanceBarEle,
				[108271] = SSA.AstralShiftBarEle,
				[2825]   = SSA.BloodlustBarEle,
				[118522] = SSA.ElementalBlastCritBar,
				[173183] = SSA.ElementalBlastHasteBar,
				[173184] = SSA.ElementalBlastMasteryBar,
				[16166]  = SSA.ElementalMasteryBar,
				[32182]  = SSA.HeroismBarEle,
				[80353]  = SSA.TimeWarpBarEle,
			},
			["main"] = {
				--[[[188616] = SSA.EarthElementalBar,
				[118323] = SSA.EarthElementalBar,
				[188592] = SSA.FireElementalBar,
				[118291] = SSA.FireElementalBar,
				[157299] = SSA.StormElementalBar,
				[157319] = SSA.StormElementalBar,]]
			},
			["utility"] = {
				[51485]  = SSA.EarthgrabTotemBarEle,
				[51514]  = SSA.HexBarEle,
				[192222] = SSA.LiquidMagmaTotemBar,
				[196932] = SSA.VoodooTotemBarEle,
				[192077] = SSA.WindRushTotemBarEle,
				[188616] = SSA.EarthElementalBar,
				[118323] = SSA.EarthElementalBar,
				[188592] = SSA.FireElementalBar,
				[118291] = SSA.FireElementalBar,
				[157299] = SSA.StormElementalBar,
				[157319] = SSA.StormElementalBar,
			},			
		},
		[2] = {
			["buff"] = {
				[114051] = SSA.AscendanceBarEnh,
				[108271] = SSA.AstralShiftBarEnh,
				--[2825]   = SSA.BloodlustBarEnh,
				--[32182]  = SSA.HeroismBarEnh,
				[58875] = SSA.SpiritWalkBar,
				--[80353]  = SSA.TimeWarBarEnh,
			},
			["main"] = {
				[218825] = SSA.BoulderfistBar,
				[187878] = SSA.CrashLightningBar,
				[193796] = SSA.FlametongueBar,
				[196834] = SSA.FrostbrandBar,
				[201898] = SSA.WindsongBar,
			},
			["utility"] = {
				[188089] = SSA.EarthenSpikeBar,
				[51485]  = SSA.EarthgrabTotemBarEnh,
				[51514]  = SSA.HexBarEnh,
				[196932] = SSA.VoodooTotemBarEnh,
				[192077] = SSA.WindRushTotemBarEnh,
			},
		},
		[3] = {
			["buff"] = {
				[108281] = SSA.AncestralGuidanceBarRes,
				[114052] = SSA.AscendanceBarRes,
				[108271] = SSA.AstralShiftBarRes,
				[2825]   = SSA.BloodlustBarRes,
				[32182]  = SSA.HeroismBarRes,
				[79206]  = SSA.SpiritwalkersGraceBar,
				[80353]  = SSA.TimeWarBarRes,
				[73685]  = SSA.UnleashLifeBar,
			},
			["main"] = {
				[207399] = SSA.AncestralProtTotemBar,
				[157153] = SSA.CloudburstTotemBar,
				[5394]   = {
					[1] = SSA.HealingStreamTotemBarOne,
					[2] = SSA.HealingStreamTotemBarTwo,
				},
				[108280] = SSA.HealingTideTotemBar,
				[98008]  = SSA.SpiritLinkTotemBar,
			},
			["utility"] = {
				[51485]  = SSA.EarthgrabTotemBarRes,
				[51514]  = SSA.HexBarRes,
				[196932] = SSA.VoodooTotemBarRes,
				[192077] = SSA.WindRushTotemBarRes,
			}
		}
	}
	
	
	miscObj = {
		[1] = {
			[1] = SSA.MaelstromBarEle,
			[3] = SSA.MainTimerBarGrpEle,
			[4] = SSA.UtilTimerBarGrpEle,
			[5] = SSA.BuffTimerBarGrpEle,
			[6] = SSA.TotemMasteryTexture,
		},
		[2] = {
			[1] = SSA.MaelstromBarEnh,
			[2] = SSA.MainTimerBarGrpEnh,
			[3] = SSA.UtilTimerBarGrpEnh,
			[4] = SSA.BuffTimerBarGrpEnh,
			[5] = SSA.StormstrikeChargeGrp,
		},
		[3] = {
			[1] = SSA.TidalWavesBar,
			[2] = SSA.MainTimerBarGrpRes,
			[3] = SSA.UtilTimerBarGrpRes,
			[4] = SSA.BuffTimerBarGrpRes,
		}
	}
	
	-- Assign Objects by Spell ID
	spellObj = {
		[1] = {
		-- Elemental
			[108281] = SSA.AncestralGuidanceEle,
			[114050] = SSA.AscendanceEle,
			[108271] = SSA.AstralShiftEle,
			--[2825]   = SSA.BloodlustEle,
			[51886]  = SSA.CleanseSpiritEle,
			[117014] = SSA.ElementalBlast,
			[198103] = SSA.EarthElemental,
			[51485]  = SSA.EarthgrabTotemEle,
			[61882]  = SSA.Earthquake,
			[8042]   = SSA.EarthShock,
			[16166]  = SSA.ElementalMastery,
			[198067] = SSA.FireElemental,
			[118291] = SSA.FireElemental,
			[188389] = SSA.FlameShock,
			[192063] = SSA.GustWindEle,
			[51514]  = SSA.HexEle, -- Frog Hex
			[210873] = SSA.HexEle, -- Raptor Hex
			[211004] = SSA.HexEle, -- Spider Hex
			[211010] = SSA.HexEle, -- Snake Hex
			[211015] = SSA.HexEle, -- Roach Hex
			[210714] = SSA.Icefury,
			[51505]  = SSA.LavaBurstEle,
			[192058] = SSA.LightningSurgeTotemEle,
			[192222] = SSA.LiquidMagmaTotem,
			[192249] = SSA.StormElemental,
			[205495] = SSA.Stormkeeper,
			[51490]  = SSA.Thunderstorm,
			[196932] = SSA.VoodooTotemEle,
			[192077] = SSA.WindRushTotemEle,
			[57994]  = SSA.WindShearEle,
		},
		[2] = {		
			-- Enhancement
			[114051] = SSA.AscendanceEnh,
			[108271] = SSA.AstralShiftEnh,
			--[2825]   = SSA.BloodlustEnh,
			[201897] = SSA.Boulderfist,
			[51886]  = SSA.CleanseSpiritEnh,
			[187874] = SSA.CrashLightning,
			[204945] = SSA.DoomWinds,
			[188089] = SSA.EarthenSpike,
			[51485]  = SSA.EarthgrabTotemEnh,
			[196884] = SSA.FeralLunge,
			[51533]  = SSA.FeralSpirit,
			[193796] = SSA.Flametongue,
			[196834] = SSA.Frostbrand,
			[51514]  = SSA.HexEnh, -- Frog Hex
			[210873] = SSA.HexEnh, -- Raptor Hex
			[211004] = SSA.HexEnh, -- Spider Hex
			[211010] = SSA.HexEnh, -- Snake Hex
			[211015] = SSA.HexEnh, -- Roach Hex
			[192058] = SSA.LightningSurgeTotemEnh,
			[215864] = SSA.Rainfall,
			[58875]  = SSA.SpiritWalk,
			[17364]  = SSA.Stormstrike,
			[197214] = SSA.Sundering,
			[196932] = SSA.VoodooTotemEnh,
			[192077] = SSA.WindRushTotemEnh,
			[201898] = SSA.Windsong,
			[57994]  = SSA.WindShearEnh,
		},
		[3] = {
			-- Restoration
			[108281] = SSA.AncestralGuidanceRes,
			[207399] = SSA.AncestralProtectionTotem,
			[114052] = SSA.AscendanceRes,
			[108271] = SSA.AstralShiftRes,
			--[2825]   = SSA.BloodlustRes,
			[157153] = SSA.CloudburstTotem,
			[198838] = SSA.EarthenShieldTotem,
			[51485]  = SSA.EarthgrabTotemRes,
			[188838] = SSA.FlameShockRes,
			[207778] = SSA.GiftOfQueen,
			[192063] = SSA.GustWindRes,
			[73920]  = SSA.HealingRain,
			[5394]   = SSA.HealingStreamTotem,
			[108280] = SSA.HealingTideTotem,
			[51514]  = SSA.HexRes, -- Frog Hex
			[210873] = SSA.HexRes, -- Raptor Hex
			[211004] = SSA.HexRes, -- Spider Hex
			[211010] = SSA.HexRes, -- Snake Hex
			[211015] = SSA.HexRes, -- Roach Hex
			[51505]  = SSA.LavaBurstRes,
			--[51505]  = SSA.LavaBurst,
			[192058] = SSA.LightningSurgeTotemRes,
			[77130]  = SSA.PurifySpirit,
			[61295]  = SSA.Riptide,
			[98008]  = SSA.SpiritLinkTotem,
			[79206]  = SSA.SpiritwalkersGrace,
			[53390]  = SSA.TidalWaves,
			[73685]  = SSA.UnleashLife,
			[196932] = SSA.VoodooTotemRes,
			[197995] = SSA.Wellspring,
			[192077] = SSA.WindRushTotemRes,
			[57994]  = SSA.WindShearRes,
		}
	}

	-- Abilities with charges
	SSA.chargedSpells = {
		[1] = {
			[51505] = true,
		},
		[2] = {
			[201897] = true,
			[17364] = true,
		},
		[3] = {
			[51505] = true,
			[61295] = true,
			[5394] = true,
		}
	}
	
	Auras:UpdateTalents();
	spec = SSA.spec;
	
	--local MaelstromBar = GetMaelstromBarObj(SSA.spec);
	local playerPower,maxPower = GetPowerInfo(L['Maelstrom']);
	local icefuryChgs = GetPowerInfo(L['Icefury']);
	
	--for i=1,2 do
		--local maxPower,playerPower = UnitPowerMax('player',11),UnitPower('player',11)
	if (spec == 1 or spec == 2) then
		InitializeStatusBar(Auras:GetMaelstromBarObj(spec),0,maxPower,playerPower,0,Auras.db.char.layout[spec].maelstromBar.width,Auras.db.char.layout[spec].maelstromBar.height); -- Initialize Maelstrom Status Bar
	end
	--InitializeStatusBar(SSA.IcefuryBar,0,4,icefuryChgs,nil,Auras.db.char.layout[1].icefuryBar.width,Auras.db.char.layout[1].icefuryBar.height); -- Initialize Icefury Status Bar
	--InitializeStatusBar(SSA.IcefuryBar.Timer,0,15); -- Initialize Icefury Timer Status Bar
	--InitializeStatusBar(SSA.EarthenShieldTotemBar,nil,nil,nil,nil,Auras.db.char.layout[3].earthenShieldBar.width,Auras.db.char.layout[3].earthenShieldBar.height) -- Initialize Earthen Shield Status Bar
	--InitializeStatusBar(SSA.EarthenShieldTotemBar.Timer,0,15) -- Initialize Earthen Shield Status Bar
	--InitializeStatusBar(SSA.CloudburstAbsorbBar.Timer,0,15) -- Initialize Cloudburst Status Bar
	--InitializeStatusBar(SSA.TidalWavesBar,0,2,0,nil,Auras.db.char.layout[3].tidalWavesBar.width,Auras.db.char.layout[3].tidalWavesBar.height); -- Initialize Tidal Wave Status Bar
	
	Auras.db.char.layout[1].maelstromBar.isAdjustable = false;
	Auras.db.char.layout[1].icefuryBar.isAdjustable = false;
	Auras.db.char.layout[2].maelstromBar.isAdjustable = false;
	Auras.db.char.layout[3].earthenShieldBar.isAdjustable = false;
	Auras.db.char.layout[3].tidalWavesBar.isAdjustable = false;
	
	-- Run Rotate Animation for Vertical Progress Bars
	--[[for i=1,3 do
		local object
		for spellID in pairs(barObj[i].buff) do
			barObj[i].buff[spellID].rotatetime:Play();
			barObj[i].buff[spellID].rotatename:Play();
		end
		for spellID in pairs(barObj[i].main) do
			if (spellID == 5394) then
				barObj[i].main[spellID][1].rotatetime:Play();
				barObj[i].main[spellID][1].rotatename:Play();
				barObj[i].main[spellID][2].rotatetime:Play();
				barObj[i].main[spellID][2].rotatename:Play();
			else
				barObj[i].main[spellID].rotatetime:Play();
				barObj[i].main[spellID].rotatename:Play();
			end
		end
		for spellID in pairs(barObj[i].utility) do
			barObj[i].utility[spellID].rotatetime:Play();
			barObj[i].utility[spellID].rotatename:Play();
		end
	end]]
	
	local dbEle = Auras.db.char.frames.eleGrp;
	local dbEnh = Auras.db.char.frames.enhGrp;
	local dbRes = Auras.db.char.frames.resGrp;
	
	if (type(dbEle) ~= "table" or type(dbEnh) ~= "table" or type(dbRes) ~= "table") then
		AlertFrame:Show();
		CreateAlert(nil,"If you're seeing this, you are running r18-beta or later, but have a corrupted database. There was a rare issue that would cause this to happen and it has been fixed. However, we need to reset your database to return everything back to working order\n\nTo do this, please do ths following:\n\n    1. Logout of the game.\n    2. Go to your WTF folder\n        a. \"C:\\Program Files(x86)\\World of Warcraft\\WTF\"\n    3. Open the \"Accounts\" folder.\n    4. Open your account's folder.\n    5. Open the \"Saved Variables\" folder.\n    6. Find and delete the following files:\n        a. ShamanAuras.lua\n        b. ShamanAuras.lua.back\n\nWhen logging back in, the issue should be fixed.\n\nEnjoy!",360,312,20,50,0,-40,"LEFT");
	--[[elseif (not Auras.db.char.version or Auras.db.char.version ~= GetVersionNumber()) then
	--elseif (Auras.db.char.version == 21) then
		local version = GetVersionNumber();
		if (not Auras.db.char.version) then
			Auras.db.char.version = version;
		end
		if (Auras.db.char.version <= 21) then
			--SSA.ErrorFrame.text:SetText("Version check");
			local desc = "Sizing and Spacing Available!\n\nYou can now resize and adjust the spacing of the auras. Simply go to the advanced settings by typing '/ssa opt' to begin!"
			CreateAlert("Interface\\addons\\ShamanAurasDev\\Media\\textures\\sizing_spacing_preview",desc,420,406,20,120,0,500,"CENTER")
		end]]
	else
		for groupObj in pairs(dbEle) do
			--SSA.ErrorFrame.text:SetText(Auras:CurText().."[ELE]: "..groupObj.."\n")
			if (groupObj == "LavaSurgeEle") then
				dbRes.groupObj = nil
			elseif (groupObj ~= "enabled" and SSA[groupObj]) then
				InitializeGroup(SSA[groupObj],dbEle[groupObj].width,dbEle[groupObj].height,dbEle[groupObj].point,dbEle[groupObj].relativeTo,dbEle[groupObj].relativePoint,dbEle[groupObj].x,dbEle[groupObj].y,1,groupObj);
			elseif (groupObj == "enabled") then
				if (dbEle[groupObj]) then
					AuraGroupEle:Show();
				else
					AuraGroupEle:Hide();
				end
			end
		end
		
		for groupObj in pairs(dbEnh) do
			--SSA.ErrorFrame.text:SetText(Auras:CurText().."[ENH]: "..groupObj.."\n")
			if (groupObj ~= "enabled" and SSA[groupObj]) then
				InitializeGroup(SSA[groupObj],dbEnh[groupObj].width,dbEnh[groupObj].height,dbEnh[groupObj].point,dbEnh[groupObj].relativeTo,dbEnh[groupObj].relativePoint,dbEnh[groupObj].x,dbEnh[groupObj].y,2,groupObj);
			elseif (groupObj == "enabled") then
				if (dbEnh[groupObj]) then
					AuraGroupEnh:Show();
				else
					AuraGroupEnh:Hide();
				end
			end
		end
		
		for groupObj in pairs(dbRes) do
			if (groupObj == "LavaSurgeRes") then
				dbRes.groupObj = nil
			elseif (groupObj ~= "enabled" and SSA[groupObj]) then
				InitializeGroup(SSA[groupObj],dbRes[groupObj].width,dbRes[groupObj].height,dbRes[groupObj].point,dbRes[groupObj].relativeTo,dbRes[groupObj].relativePoint,dbRes[groupObj].x,dbRes[groupObj].y,3,groupObj);
			elseif (groupObj == "enabled") then
				if (dbRes[groupObj]) then
					AuraGroupRes:Show();
				else
					AuraGroupRes:Hide();
				end
			end
		end
	end

	
	-- Continuously check for targets, their types, and if they're in range
	Frame:SetScript("OnUpdate",function(self)
		if (Auras:CharacterCheck(0)) then
			local spec = SSA.spec;
			local name = GetSpecName(spec):lower()
			local isExist,isCombat,isFriend,isDead = GetTargetInfo();
			local p,rT,rP,x,y
			
			SSA.DataFrame.text:SetText("----- Buffs -----\n");
			for i=1,getn(loadedBuffBars) do
				if (loadedBuffBars[i]) then
					p,rT,rP,x,y = barObj[SSA.spec].buff[loadedBuffBars[i]]:GetPoint();
					SSA.DataFrame.text:SetText(Auras:CurText("DataFrame")..Auras:GetSpellName(loadedBuffBars[i])..": \""..p.."\", "..tostring(rT:GetName())..", \""..rP.."\", "..x..", "..y.."\n")
				end
			end
			SSA.DataFrame.text:SetText(Auras:CurText("DataFrame").."\n\n----- Main -----\n");
			for i=1,getn(loadedMainBars) do
				if (loadedMainBars[i]) then
					if (loadedMainBars[i] == 53941 or loadedMainBars[i] == 53942) then
						if (loadedMainBars[i] == 53941) then
							p,rT,rP,x,y = barObj[SSA.spec].main[5394][1]:GetPoint();
						elseif (loadedMainBars[i] == 53942) then
							p,rT,rP,x,y = barObj[SSA.spec].main[5394][2]:GetPoint();
						end
						SSA.DataFrame.text:SetText(Auras:CurText("DataFrame")..Auras:GetSpellName(5394).." ("..tostring(5394).."): \""..p.."\", "..tostring(rT:GetName())..", \""..rP.."\", "..x..", "..y.."\n")
					else
						p,rT,rP,x,y = barObj[SSA.spec].main[loadedMainBars[i]]:GetPoint();
						SSA.DataFrame.text:SetText(Auras:CurText("DataFrame")..Auras:GetSpellName(loadedMainBars[i]).." ("..tostring(loadedMainBars[i]).."): \""..p.."\", "..tostring(rT:GetName())..", \""..rP.."\", "..x..", "..y.."\n")
					end
				end
			end
			SSA.DataFrame.text:SetText(Auras:CurText("DataFrame").."\n\n----- Utility -----\n");
			for i=1,getn(loadedUtilBars) do
				if (loadedUtilBars[i]) then
					p,rT,rP,x,y = barObj[SSA.spec].utility[loadedUtilBars[i]]:GetPoint();
					SSA.DataFrame.text:SetText(Auras:CurText("DataFrame")..Auras:GetSpellName(loadedUtilBars[i])..": \""..p.."\", "..tostring(rT:GetName())..", \""..rP.."\", "..x..", "..y.."\n")
				end
			end
			if (not SSA.IsMovingAuras) then
				if (spec == 1) then
					--[[local power = UnitPower('player',11);
					local buff = UnitBuff('player',Auras:GetSpellName(208723));
					
					if (power >= 50 or buff) then
						Auras:AdjustIconDisplay(SSA.Earthquake,1,1,1,1);
					else
						Auras:AdjustIconDisplay(SSA.Earthquake,0.5,0.5,0.5,0.5);
					end]]
				elseif (spec == 2) then
					--[[local power = UnitPower('player',11);
					
					if (power >= 20) then
						Auras:AdjustIconDisplay(SSA.CrashLightning,1,1,1,1);
						Auras:AdjustIconDisplay(SSA.Frostbrand,1,1,1,1);
					else
						Auras:AdjustIconDisplay(SSA.CrashLightning,0.5,0.5,0.5,0.5);
						Auras:AdjustIconDisplay(SSA.Frostbrand,0.5,0.5,0.5,0.5);
					end]]
				elseif (spec == 3) then
					local buff,_,_,count = UnitBuff('player',Auras:GetSpellName(53390));
					if (not Auras.db.char.layout[3].tidalWavesBar.isAdjustable) then
						local barColor = Auras.db.char.layout[3].tidalWavesBar.emptyColor;
						if (isCombat) then
							if (buff) then
								--Auras:UpdateTidalWaveBar(0.5,{0.35,0.76,1},false,count);
							else
								--Auras:UpdateTidalWaveBar(0,{barColor.r,barColor.g,barColor.b},Auras.db.char.triggers.res.animTidalWaves,2);
							end
						else
							if (isExist and isFriend) then
								if (not buff) then
									--Auras:UpdateTidalWaveBar(0,{barColor.r,barColor.g,barColor.b},Auras.db.char.triggers.res.animTidalWaves,2);
								else
									--Auras:UpdateTidalWaveBar(0.5,{0.35,0.76,1},false,count)
								end
							else
								--SSA.TidalWavesBar:SetAlpha(0);
							end
						end
					else
						--Auras:UpdateTidalWaveBar(0.5,{0.35,0.76,1},false,2);
						--SSA.TidalWavesBar:Show();
					end
				end
				if (isExist) then
					if (isCombat) then
						if (not isFriend and not isDead) then
							if (spec == 1) then
								if (TotemMasteryCheck()) then
									--[[SSA.TotemMastery.Flash:Play();
									SSA.TotemMastery:Show();
									SSA.TotemMastery.Flash.fadeOut:SetToAlpha(1);
									SSA.TotemMastery.Flash.fadeIn:SetFromAlpha(1);]]
								else
									--SSA.TotemMastery:Hide();
								end
							else
								--SSA.TotemMastery:Hide();
							end

							for spellID in pairs(spellObj[spec]) do
								if (not resourceCheck[spec][spellID]) then
									--Auras:AdjustIconDisplay(spellObj[spec][spellID],1,1,1,1);
								end
							end
						end
						TargetCheck(name,1,isExist,isCombat,isFriend,isDead);
					else
						if (not isFriend and not isDead) then
							if (spec == 1) then
								if (TotemMasteryCheck()) then
									--[[SSA.TotemMastery.Flash:Play();
									SSA.TotemMastery:Show();
									SSA.TotemMastery.Flash.fadeOut:SetToAlpha(0.6);
									SSA.TotemMastery.Flash.fadeIn:SetFromAlpha(0.6);]]
								else
									--SSA.TotemMastery:Hide();
								end
							else
								--SSA.TotemMastery:Hide();
							end
						end
						
						for spellID in pairs(spellObj[spec]) do
							--Auras:AdjustIconDisplay(spellObj[spec][spellID],1,1,1,Auras.db.char.triggers[name].OoCAlpha);
							--spellObj[spec][spellID].texture:SetDesaturated(false);
							if (SSA[spellObj[spec][spellID]:GetName()].glow) then
								--Auras:ToggleOverlayGlow(SSA[spellObj[spec][spellID]:GetName()].glow,false)
							end
						end
						--TargetCheck(name,0.5,isExist,isCombat,isFriend,isDead);
					end
				else
					if (not TotemMasteryCheck()) then
						--SSA.TotemMastery:Hide();
					end
					for spellID in pairs(spellObj[spec]) do
						--Auras:AdjustIconDisplay(spellObj[spec][spellID],1,1,1,Auras.db.char.triggers[name].OoCAlpha);
						--spellObj[spec][spellID].texture:SetDesaturated(false);
						if (SSA[spellObj[spec][spellID]:GetName()].glow) then
							--Auras:ToggleOverlayGlow(SSA[spellObj[spec][spellID]:GetName()].glow,false)
						end
					end
				end
			else
				if (spec == 1 or spec == 2) then
					--Auras:GetMaelstromBarObj(spec):SetAlpha(1);
				elseif (spec == 3) then
					--SSA.Undulation:SetAlpha(1);
					--Auras:UpdateTidalWaveBar(0.5,{0.35,0.76,1},false,2)
				end
			end
		end
		--SSA.ErrorFrame.text:SetText("Alpha: "..tostring(SSA.TidalWavesBar:GetAlpha()).."\nShown: "..tostring(SSA.TidalWavesBar:IsShown()));
	end);
	StaticPopupDialogs["SSA_CLASS_CHECKER"] = {
		text = "You are currently running the addon \"Sweetsour's Shaman Auras\" while on a non-shaman character. Would you like to disable this addon for this character?",
		button1 = "Yes",
		button2 = "No",
		OnAccept = function()
			DisableAddOn("ShamanAuras");
			DisableAddOn("ShamanAurasDev");
			ReloadUI();
		end,
		timeout = 0,
		whileDead = true,
		hideOnEscape = true,
		preferredIndex = 3,
	}
	
	if (not Auras:CharacterCheck(0)) then
		StaticPopup_Show ("SSA_CLASS_CHECKER")
	end
end

local function UpdateFlameShock(object,frame,spellID)
--[[	--local name = GetSpellInfo(spellID);
	local debuff,_,_,_,_,duration,expires,caster = UnitDebuff('target',Auras:GetSpellName(spellID));
	
	
	if (not frame.text) then
		local fontsize = nil;
		if (spellID == 188838) then
			fontsize = 16;
		else
			fontsize = 18;
		end

		frame.text = frame:CreateFontString(nil, "HIGH", "GameFontHighlightLarge");
		frame.text:SetPoint("CENTER",0.5,0.5);
		frame.text:SetFont("Interface\\addons\\ShamanAuras\\media\\fonts\\PT_Sans_Narrow.TTF", fontsize,"OUTLINE");
		frame.text:SetTextColor(1,1,0,1);
	end
	
	object:SetScript("OnUpdate",nil);
	if (debuff and caster == 'player') then
		object:SetScript("OnUpdate", function(self,elapsed)
			local timer,seconds = Auras:parseTime(expires - GetTime(),false);

			frame.text:SetText(timer);
			
			if (seconds <= Auras.db.char.triggers.ele.flameShock and UnitAffectingCombat('player')) then
				Auras:ToggleOverlayGlow(object,true,true);
			else
				Auras:ToggleOverlayGlow(object,false);
			end
			if (seconds == 0) then
				frame.text:SetText('');
				self:SetScript("OnUpdate",nil);
			end
		end);
	else
		frame.text:SetText('');
		if (UnitExists('target') and not UnitIsFriend('target','player') and not UnitIsDead('target') and UnitAffectingCombat('player')) then
			Auras:ToggleOverlayGlow(object,true,true);
		else
			Auras:ToggleOverlayGlow(object,false);
		end
	end]]
end

function Auras:UpdateEarthenShield(self)
	local progress = ((Auras.db.char.info.totems.eShield.dmg or 0) / Auras.db.char.info.totems.eShield.hp * 100);
	progress = 100 - progress;
	local remains = (Auras.db.char.info.totems.eShield.hp - (Auras.db.char.info.totems.eShield.dmg or 0));
	
	if (remains > 0) then
		self:SetValue(remains);
		self.text:SetText(tostring(math.ceil(progress)).."%");
	else
		self:SetAlpha(0);
		self.Timer:SetAlpha(0);
		--SSA.EarthenShieldTotemBar.Timer:Hide();
	end
end

local function UpdateLavaSurge(object,spellID)
	--[[local name = GetSpellInfo(spellID);
	local buff,_,_,_,_,duration,expires = UnitBuff('player',Auras:GetSpellName(spellID));

	object:SetScript("OnUpdate",nil);
	object:SetScript("OnUpdate", function(self,elapsed)
		if (buff) then
			local remaining = expires - GetTime();

			if (remaining > 0) then
				self:SetValue(remaining);
			else
				Auras:ToggleOverlayGlow(SSA.LavaBurstGlow,false);
				self:Hide();
				self.scaler:Stop();
				self:SetScript("OnUpdate",nil);
			end
		else
			self.scaler:Stop();
		end
	end);]]
end

--[[ To Enable Enhancement:
Auras:SetupCharges() -- SA_Core.lua
Auras:BuildMoveUI() -- SA_Init.lua
Auras:CreateVerticalStatusBar() -- SA_Init.lua
Auras:ChargeCooldown() -- SA.Core.lua
SA_Enhancement.lua
Auras:UNIT_POWER -- SA_Core.lua
SA_Core.lua (2255)
]]
--[[function Auras:SetupCharges()
	local spec = SSA.spec;
	if (Auras:ClassCheck()) then
		for spellID in pairs(SSA.chargedSpells[spec]) do
			local charges,maxCharges = GetSpellCharges(spellID);
			local object = spellObj[spec][spellID];

			--if ((SSA.isEoE or spec == 2) and spec ~= 2) then -- CHANGE FOR ENH
			if (SSA.isEoE or spec == 2) then
				if (spellID == 17364) then
					if (Auras.db.char.aura[2].StormstrikeChargesText and select(4,GetTalentInfo(5,1,1))) then
						object.Charges:Show();
						object.Charges.text:SetText("2");
					else
						object.Charges:Hide();
					end
				else
					object.Charges:Show();
					object.Charges.text:SetText("2");
				end
			else
				--if (spec ~= 2) then
					object.Charges:Hide();
				--end
			end
		end
	end
end

function Auras:ChargeCooldown()
	local spec,isCharges = SSA.spec,false
	--if (spec ~= 2) then
		if (spec == 2) then
			if (select(4,GetTalentInfo(1,3,1)) or (select(4,GetTalentInfo(5,1,1)) and Auras.db.char.aura[2].StormstrikeChargesText)) then
				isCharges = true;
			end
		elseif (SSA.isEoE) then
			isCharges = true;
		end
		if (isCharges) then
			for spellID in pairs(SSA.chargedSpells[spec]) do
				local charges,maxCharges,start,duration = GetSpellCharges(spellID);
				local object = spellObj[spec][spellID];
				local ChargeCD = SSA[object:GetName()].ChargeCD;
				local ChargeText = SSA[object:GetName()].Charges;

				if (charges ~= maxCharges) then
					ChargeCD:SetCooldown(start,duration);
					ChargeText.text:SetText(charges);
				else
					ChargeText.text:SetText(charges);
				end
			end
		end
	--end
end]]

function Auras:SPELL_UPDATE_USABLE()
	--ExecuteCooldown();
end

function Auras:PLAYER_ENTERING_WORLD()
	--local name = GetSpellInfo(53390);
	local buff,_,_,count = UnitBuff('player',Auras:GetSpellName(53390));
	if (not buff) then
		--Auras:UpdateTidalWaveBar(0,{1,0,0},Auras.db.char.triggers.res.animTidalWaves,2);
	else
		--Auras:UpdateTidalWaveBar(0.5,{0.35,0.76,1},false,count);
	end
end

function Auras:ADDON_LOADED(event,addon)
	if (event ~= "ADDON_LOADED") then
		return;
	end

	if (addon == "Blizzard_TalentUI") then
		--[[PlayerTalentFrame:HookScript("OnShow",function(self)
			InterfaceOptionsFrame:Hide();
		end);]]
	end
	--self:UnregisterEvent(event);
end

function Auras:PLAYER_LOGIN(event)
	--ExecuteCooldown();
	
	self:UnregisterEvent(event);
end

function Auras:PLAYER_LEVEL_UP(event,level)
	--LevelCheck(level);
end

function Auras:PLAYER_TALENT_UPDATE()
	Auras:UpdateTalents();
	Auras:UpdateInterfaceSettings();
	local spec = SSA.spec;

	local playerPower,maxPower
	local updateTime = GetTime();
	
	if (spec == 1 or spec == 2) then
		UpdateFrame:SetScript("OnUpdate",function(self,elapsed)
			
	
			if ((GetTime() - updateTime) > 2) then
				playerPower,maxPower = GetPowerInfo(L['Maelstrom']);
				InitializeStatusBar(Auras:GetMaelstromBarObj(SSA.spec),0,maxPower,playerPower,0,Auras.db.char.layout[spec].maelstromBar.width,Auras.db.char.layout[spec].maelstromBar.height);
				self:SetScript("OnUpdate",nil);
			end
		end);
	end
end
local iLvlFrm
function Auras:PLAYER_TARGET_CHANGED()
	local spec = SSA.spec;
	--if (spec == 1 or spec == 2) then
	if (spec == 1 or spec == 2) then
		if (spec == 1) then
			UpdateFlameShock(SSA.FlameShock.glow,SSA.FlameShock,188389);
		end
		--Auras:MaelstromAlpha();
	elseif (spec == 3) then
		UpdateFlameShock(SSA.FlameShockRes.glow,SSA.FlameShockRes,188838);
	end

	
	--[[if (isTotemMastery) then
		--local name = GetSpellInfo(210660);
		local buff = UnitBuff('player',GetSpellName(210660));
		if (buff or not IsEnemyTarget()) then 
			SSA.TotemMastery:Hide();
			SSA.TotemMasteryAlpha:Stop();
		else
			SSA.TotemMastery:Show();
			SSA.TotemMasteryAlpha:Play();
		end
	end]]
	--[[if (UnitExists('target')) then
		local fade = false;
		local isRange,isEnemy,isFriend,isDead = false,false,false,false;
		
		
	else
		Frame:SetScript("OnUpdate",nil);
	end]]
	--TargetCheck();
end

function Auras:PLAYER_REGEN_DISABLED()
	Auras:MaelstromAlpha();
	if (SSA["Move"..GetSpecName(SSA.spec)]:IsShown()) then
		if (SSA["Move"..GetSpecName(SSA.spec)].Unlock:IsEnabled()) then
			SSA["Move"..GetSpecName(SSA.spec)].Unlock:Click();
		end
		SSA["Move"..GetSpecName(SSA.spec)].Close:Click("MiddleButton");
	end
end

function Auras:PLAYER_REGEN_ENABLED(event)
	local spec = SSA.spec
	for spellID in pairs(spellObj[spec]) do
		if (spellObj[spec][spellID].glow) then
			--Auras:ToggleOverlayGlow(spellObj[spec][spellID].glow,false)
		end
	end
	--Auras:MaelstromAlpha();
	--ExecuteCooldown();
end

function Auras:UNIT_POWER(event,unit,powerType)
	local spec = SSA.spec;

	if (unit == 'player' and not Auras.db.char.layout[1].maelstromBar.isAdjustable and not Auras.db.char.layout[2].maelstromBar.isAdjustable and (Auras.db.char.triggers.ele.MaelstromAnim or Auras.db.char.triggers.enh.MaelstromAnim)) then		
		if (powerType == "MAELSTROM" and spec ~= 3) then
			local MaelstromBar,trigger = Auras:GetMaelstromBarObj(spec);
			local playerPower,maxPower = GetPowerInfo("Maelstrom");

			if (playerPower >= trigger) then
				--[[MaelstromBar.Lightning:SetModel("SPELLS/LIGHTNING_AREA_DISC_STATE.m2");
				MaelstromBar.Lightning:SetAlpha(1);
				MaelstromBar.bg:SetAlpha(1);]]

				if (spec == 1 and UnitAffectingCombat('player')) then
					--Auras:ToggleOverlayGlow(SSA.EarthShock.glow,true);
				end
			else
				--[[MaelstromBar.Lightning:SetAlpha(0);
				MaelstromBar.bg:SetAlpha(0.5);]]

				if (spec == 1 and UnitAffectingCombat('player')) then
					--Auras:ToggleOverlayGlow(SSA.EarthShock.glow,false);
				end
			end
			
			if (spec == 1) then
				local buff = UnitBuff('player',Auras:GetSpellName(208723));
					
				if ((playerPower >= 50 or buff) and UnitAffectingCombat('player')) then
					--Auras:AdjustIconDisplay(SSA.Earthquake,1,1,1,1);
				else
					--Auras:AdjustIconDisplay(SSA.Earthquake,0.5,0.5,0.5,0.5);
				end
			elseif (spec == 2) then
				--[[if (playerPower >= 20 and UnitAffectingCombat('player')) then
					Auras:AdjustIconDisplay(SSA.CrashLightning,1,1,1,1);
					Auras:AdjustIconDisplay(SSA.Frostbrand,1,1,1,1);
				else
					Auras:AdjustIconDisplay(SSA.CrashLightning,0.5,0.5,0.5,0.5);
					Auras:AdjustIconDisplay(SSA.Frostbrand,0.5,0.5,0.5,0.5);
				end
				if (playerPower >= 40 and UnitAffectingCombat('player')) then
					Auras:AdjustIconDisplay(SSA.Stormstrike,1,1,1,1);
				else
					Auras:AdjustIconDisplay(SSA.Stormstrike,0.5,0.5,0.5,0.5);
				end]]
			end
					
			--MaelstromBar:SetValue(playerPower);
			--MaelstromBar.text:SetText(playerPower);
		end
	end
	
end
local function ToggleLightningOrbs(spellID)
	--local name = GetSpellInfo(spellID);
	local _,_,_,count = UnitBuff('player',Auras:GetSpellName(spellID));
	local elapsed = 0;

	--[[if (count == 2) then
		StormstrikeCharge1:Show();
		StormstrikeCharge1.Lightning:SetScript("OnUpdate", function(self, elaps)
			elapsed = elapsed + (elaps * 1000);
			self:SetSequenceTime(1, elapsed);
		end);
		StormstrikeCharge2:Show();
		StormstrikeCharge2.Lightning:SetScript("OnUpdate", function(self, elaps)
			elapsed = elapsed + (elaps * 1000);
			self:SetSequenceTime(1, elapsed);
		end);
	elseif (count == 1) then
		
		if (select(4,GetTalentInfo(5,1,1))) then
			StormstrikeCharge2:Hide();
			StormstrikeCharge2.Lightning:SetScript("OnUpdate", nil);
		else
			StormstrikeCharge1:Show();
			StormstrikeCharge1.Lightning:SetScript("OnUpdate", function(self, elaps)
			elapsed = elapsed + (elaps * 1000);
			self:SetSequenceTime(1, elapsed);
		end);
		end
	elseif (count == 0) then
		StormstrikeCharge1:Hide();
		StormstrikeCharge1.Lightning:SetScript("OnUpdate", nil);
	end]]
end

local function RunMainDurationBar(object,barTable,spellID,startTime)
	--table.insert(barTable,spellID);
	local expires,duration
	object:Show();
	object:SetScript("OnUpdate", function(self,elapsed)
		if (totemObj[spec][spellID] or spellID == 53941 or spellID == 53942) then
			expires = startTime + self.duration;
		else
			_,_,_,_,_,duration,expires = UnitBuff('player',Auras:GetSpellName(spellID));
			if (duration > 1.6) then
				self:SetMinMaxValues(0,duration);
			end
		end
		local timer,seconds = Auras:parseTime((expires - GetTime()),true);
	
		for i=1,getn(barTable) do
			if (barTable[i] == spellID) then
				self:SetPoint("RIGHT",((i-1) * -20) + -5,0);
			end
		end
		
		if (seconds > 0.1) then
			self.timetext:SetText(timer);
			self:SetValue(seconds);
		else
			self:SetScript("OnUpdate",nil);
			self:Hide();
			for i=1,getn(barTable) do
				if (barTable[i] == spellID) then
					table.remove(barTable,i);
				end
			end
		end
	end)
end

function Auras:COMBAT_LOG_EVENT_UNFILTERED(eventname,...)
	if (eventname ~= "COMBAT_LOG_EVENT_UNFILTERED") then
		return;
	end
	
	local spec = SSA.spec;
	local PlayerGUID = UnitGUID('player');
	local _,subevent,_,SourceGUID,source = ...;
	local spellID = select(12,...) or 0;
	local startTime = GetTime();
	local isValidObject,objectName

	if (SourceGUID == PlayerGUID and Auras:CharacterCheck(0)) then
		if (spells[spec][spellID] or barObj[spec].buff[spellID] or barObj[spec].main[spellID] or barObj[spec].utility[spellID]) then
			--isValidObject = true
			if (barObj[spec].buff[spellID]) then
				objectName = barObj[spec].buff[spellID]:GetName();
			elseif (barObj[spec].main[spellID]) then
				if (spellID == 5394) then
					local charges = GetSpellCharges(5394);
					
					if (charges == 1) then
						objectName = barObj[spec].main[spellID][1]:GetName();
					elseif (charges == 0) then
						objectName = barObj[spec].main[spellID][2]:GetName();
					end
				else
					objectName = barObj[spec].main[spellID]:GetName();
				end
			elseif (barObj[spec].utility[spellID]) then
				objectName = barObj[spec].utility[spellID]:GetName();
			end
		end
		if (subevent == "SPELL_SUMMON" and spells[spec][spellID]) then
			if (spellID == 188592) then -- Fire Elemental
				--[[local expires,duration
				isFireStormElemental = true;
				GUIDs[L["Greater Fire Elemental"] = SSA.FireElementalBar; -- add second bracket
				SSA.FireElementalBar:Show();
				SSA.FireElementalBar:SetScript("OnUpdate", function(self,elapsed)
					expires = startTime + 60;
					local timer,seconds = Auras:parseTime((expires - GetTime()),true);
					if (seconds > 0.1) then
						self.timetext:SetText(timer);
						self:SetValue(seconds);
					else
						isFireStormElemental = false;
						self:SetScript("OnUpdate",nil);
						self:Hide();
						GUIDs[L["Fire Elemental"] = nil; -- add second bracket
					end
				end);]]
			elseif (spellID == 157299) then -- Storm Elemental
				--[[isFireStormElemental = true;
				local expires,duration
				GUIDs[L["Greater Storm Elemental"] = SSA.StormElementalBar; -- add second bracket
				SSA.StormElementalBar:Show();
				SSA.StormElementalBar:SetScript("OnUpdate", function(self,elapsed)
					expires = startTime + 60;
					local timer,seconds = Auras:parseTime((expires - GetTime()),true);
					if (seconds > 0.1) then
						self.timetext:SetText(timer);
						self:SetValue(seconds);
					else
						isFireStormElemental = false;
						self:SetScript("OnUpdate",nil);
						self:Hide();
						GUIDs[L["Storm Elemental"] = nil; -- add second bracket
					end
				end);]]
			elseif (spellID == 188616) then -- Earth Elemental
				--[[isEarthElemental = true;
				local expires,duration
				GUIDs[L["Greater Earth Elemental"] = SSA.EarthElementalBar; -- add second bracket
				SSA.EarthElementalBar:Show();
				SSA.EarthElementalBar:SetScript("OnUpdate", function(self,elapsed)
					expires = startTime + 15;
					local timer,seconds = Auras:parseTime((expires - GetTime()),true);

					if (isFireStormElemental) then
						self:SetPoint("CENTER",230,-125);
					else
						self:SetPoint("CENTER",210,-125);
					end
					if (seconds > 0.1) then
						self.timetext:SetText(timer);
						self:SetValue(seconds);
					else
						isEarthElemental = false;
						self:SetScript("OnUpdate",nil);
						self:Hide();
						GUIDs[L["Earth Elemental"] = nil; -- add second bracket
					end
				end);]]
			elseif (spellID == 198838) then -- Earthen Shield Totem
				--[[local expires = GetTime() + 15;
				if (SSA.EarthenShieldTotemBar:GetAlpha() == 0) then
					SSA.EarthenShieldTotemBar:SetAlpha(1);
				end
				SSA.EarthenShieldTotemBar:SetMinMaxValues(0,UnitHealthMax('player')) -- Initialize Earthen Shield Status Bar
				
				SSA.EarthenShieldTotemBar:Show();
				SSA.EarthenShieldTotemBar.Timer:Show();
				Auras.db.char.info.totems.eShield.hp = UnitHealthMax('player');
				Auras.db.char.info.totems.eShield.dmg = 0;
				--Auras.db.char.cooldowns[spellID] = GetTime();
				SSA.EarthenShieldTotemBar.Timer:SetScript("OnUpdate",function(self,elapsed)
					local timer,seconds = Auras:parseTime((expires - GetTime()),true);
					if ((seconds or 0) > 0.1) then
						self:SetValue(seconds);
						self.text:SetText(timer);
					else
						self:SetValue(0);
						self.text:SetText('');
						SSA.EarthenShieldTotemBar:Hide();
						SSA.EarthenShieldTotemBar.Timer:Hide();
						self:SetScript("OnUpdate",nil);
					end
				end);]]
			elseif (spellID == 157153) then -- Cloudburst Totem
				if (not SSA.Cloudburst:IsShown()) then
					SSA.Cloudburst:Show()
				end
				--[[local absorbed,duration
				SSA.Cloudburst:SetAlpha(1);
				SSA.Cloudburst.text:SetText('0');
				SSA.Cloudburst:SetScript("OnUpdate",function(self,elapsed)
					absorbed = select(17,UnitBuff('player',"Cloudburst Totem"));
					duration = GetTime() - startTime;
					
					if (absorbed) then
						if (self:GetAlpha() == 0) then
							self:SetAlpha(1);
						end
						self.text:SetText(absorbed)
					elseif (not absorbed and duration >= 2) then
						self:SetAlpha(0);
						self.text:SetText('0');
						self:SetScript("OnUpdate",nil);
						SSA.CloudburstTotemBar:Hide();
					end
				end);]]
				--[[ WORK IN PROGRESS
				local expires = GetTime() + 15;
				local absorb = Auras.db.char.triggers.res.cloudburst
				local curAbsorb
				SSA.CloudburstAbsorbBar:SetMinMaxValues(0,absorb);
				SSA.CloudburstAbsorbBar:SetValue(0);
				SSA.CloudburstAbsorbBar:Show();
				--SSA.ErrorFrame.text:SetText("Totem: "..tostring(SSA.CloudburstAbsorbBar.Timer:GetName()));
				--SSA.CloudburstAbsorbBar.Timer:Show();
				SSA.CloudburstAbsorbBar.Timer:Show();
				SSA.CloudburstAbsorbBar:SetScript("OnUpdate",function(self,elapsed)
					local timer,seconds = Auras:parseTime((expires - GetTime()),true);
					curAbsorb = select(17,UnitBuff('player',"Cloudburst Totem"));
					if ((seconds or 0) > 0.1) then
						self.Timer:SetValue(seconds);
						self.Timer.text:SetText(timer);
						self:SetValue(curAbsorb or 0);
						self.text:SetText(tostring(curAbsorb));
					else
						self:SetValue(0);
						self.Timer:SetValue(0);
						self.Timer.text:SetText('');
						self.text:SetText('');
						self:Hide();
						self.Timer:Hide();
						self:SetScript("OnUpdate",nil);
					end
				end);]]
			else
				--Auras.db.char.cooldowns[spellID] = GetTime();
			end
			if (barObj[spec].main[spellID] and Auras.db.char.aura[spec][objectName]) then
				--[[if (spellID == 5394) then
					local charges = GetSpellCharges(spellID);
					if (charges == 1) then
						table.insert(loadedMainBars,53941);
						RunMainDurationBar(SSA.HealingStreamTotemBarOne,loadedMainBars,53941,startTime);
					elseif (charges == 0) then
						table.insert(loadedMainBars,53942);
						RunMainDurationBar(SSA.HealingStreamTotemBarTwo,loadedMainBars,53942,startTime);
					end
				else
					table.insert(loadedMainBars,spellID);
					RunMainDurationBar(barObj[spec].main[spellID],loadedMainBars,spellID,startTime);
				end]]
				--[[local x = 0;
				
				table.insert(loadedMainBars,spellID);
				barObj[spec].main[spellID]:Show();
				barObj[spec].main[spellID]:SetScript("OnUpdate", function(self,elapsed)
					local expires = startTime + self.duration;
					local timer,seconds = Auras:parseTime((expires - GetTime()),true);
				
					for i=1,getn(loadedMainBars) do
						if (loadedMainBars[i] == spellID) then
							self:SetPoint("RIGHT",((i-1) * -20) + -5,0);
						end
					end
					if (seconds > 0) then
						self.timetext:SetText(timer);
						self:SetValue(seconds);
					else
						self:SetScript("OnUpdate",nil);
						self:Hide();
						for i=1,getn(loadedMainBars) do
							if (loadedMainBars[i] == spellID) then
								table.remove(loadedMainBars,i);
							end
						end
					end
				end);]]
			end

			--if (barObj[spec].utility[spellID] and Auras.db.char.aura[spec][barObj[spec].utility[spellID]:GetName()]) then
			if (barObj[spec].utility[spellID] and Auras.db.char.aura[spec][objectName]) then
			--[[	local x = 0;
				local duration,expires
				table.insert(loadedUtilBars,spellID);
				barObj[spec].utility[spellID]:Show();
				barObj[spec].utility[spellID]:SetScript("OnUpdate", function(self,elapsed)
					if (totemObj[spec][spellID]) then
						expires = startTime + self.duration;
					else
						_,_,_,_,_,duration,expires = UnitBuff('player',Auras:GetSpellName(spellID));
						if (duration > 1.6) then
							self:SetMinMaxValues(0,duration);
						end
					end
					local timer,seconds = Auras:parseTime((expires - GetTime()),true);

					x = (getn(loadedMainBars) * -25) + -190;
					for i=1,getn(loadedUtilBars) do
						if (loadedUtilBars[i] == spellID) then
							if (spec == 2 ) then
								SSA.UtilTimerBarGrpEnh:SetPoint("RIGHT",UIParent,"CENTER",x,-125);
							elseif (spec == 3) then
								SSA.UtilTimerBarGrpRes:SetPoint("RIGHT",UIParent,"CENTER",x,-125);
							end
							self:SetPoint("RIGHT",((i-1) * -20) + -5,0);
						end
					end
					
					if (seconds > 0.1) then
						self.timetext:SetText(timer);
						self:SetValue(seconds);
					else
						self:SetScript("OnUpdate",nil);
						self:Hide();
						for i=1,getn(loadedUtilBars) do
							if (loadedUtilBars[i] == spellID) then
								table.remove(loadedUtilBars,i);
							end
						end
					end
				end);]]
			end
		elseif (subevent == "SPELL_CAST_SUCCESS" and (spells[spec][spellID] or barObj[spec].buff[spellID] or barObj[spec].main[spellID])) then -- Lava Burst
			--Auras.db.char.cooldowns[spellID] = GetTime();
			if (spellID == 196840 and isIcefury) then	-- Frost Shock & Icefury Check
				--[[SSA.IcefuryBar:SetScript("OnUpdate", function(self,elapsed)
					local icefuryChgs = GetPowerInfo('Icefury');
					self:SetValue(icefuryChgs or 0);
				end);]]
			elseif (spellID == 114050) then -- Ascendance (Elemental)
				--ToggleCooldownSwipe(SSA.LavaBurstEle.CD,false);
			elseif (spellID == 193796) then -- Flametongue
				--[[local expires,remains
				spellObj[spec][spellID]:SetScript("OnUpdate", function(self,elapsed)
					--local name = GetSpellInfo(spellID);
					_,_,_,_,_,_,expires = UnitBuff('player',Auras:GetSpellName(spellID));
					remains = (expires or 0) - GetTime();

					if (remains > Auras.db.char.triggers.enh.flametongue) then
						Auras:ToggleOverlayGlow(SSA[self:GetName()].glow,false);
					elseif (remains <= 0.1) then
						self:SetScript("OnUpdate",nil);
					elseif (remains < Auras.db.char.triggers.enh.flametongue and UnitAffectingCombat('player')) then
						Auras:ToggleOverlayGlow(SSA[self:GetName()].glow,true);
					end
				end);]]
			elseif (spellID == 196834) then -- Frostbrand
				--[[local expires,remains
				spellObj[spec][spellID]:SetScript("OnUpdate", function(self,elapsed)
					--local name = GetSpellInfo(spellID);
					_,_,_,_,_,_,expires = UnitBuff('player',Auras:GetSpellName(spellID));
					remains = (expires or 0) - GetTime();
					
					if (remains > Auras.db.char.triggers.enh.frostbrand) then
						Auras:ToggleOverlayGlow(SSA[self:GetName()].glow,false);
					--elseif (remains <= 0.1) then
						--self:SetScript("OnUpdate",nil);
					elseif (remains < Auras.db.char.triggers.enh.frostbrand and UnitAffectingCombat('player')) then
						Auras:ToggleOverlayGlow(SSA[self:GetName()].glow,true);
					end
				end);]]
			elseif (spellID == 201897) then -- Boulderfist
				--[[local expires,remains
				spellObj[spec][spellID]:SetScript("OnUpdate", function(self,elapsed)
					--local name = GetSpellInfo(spellID);
					_,_,_,_,_,_,expires = UnitBuff('player',Auras:GetSpellName(spellID));
					remains = (expires or 0) - GetTime();
					
					if (remains > Auras.db.char.triggers.enh.boulderfist) then
						Auras:ToggleOverlayGlow(SSA[self:GetName()].glow,false);
					elseif (remains <= 0.1) then
						self:SetScript("OnUpdate",nil);
					elseif (remains < Auras.db.char.triggers.enh.boulderfist and UnitAffectingCombat('player')) then
						Auras:ToggleOverlayGlow(SSA[self:GetName()].glow,true);
					end
				end);]]
			end

			--if (barObj[spec].buff[spellID] and Auras.db.char.aura[spec][barObj[spec].buff[spellID]:GetName()] and barObjIndex[spellID] == subevent) then
			if (barObj[spec].buff[spellID] and Auras.db.char.aura[spec][objectName] and barObjIndex[spellID] == subevent) then
			--[[	local x = 0;
				local expires,duration
				table.insert(loadedBuffBars,spellID);
				barObj[SSA.spec].buff[spellID]:Show();
				barObj[SSA.spec].buff[spellID]:SetScript("OnUpdate", function(self,elapsed)
					--local expires = startTime + self.duration;
					_,_,_,_,_,duration,expires = UnitBuff('player',Auras:GetSpellName(spellID));
					local timer,seconds = Auras:parseTime((expires - GetTime()),true);
				
					for i=1,getn(loadedBuffBars) do
						if (loadedBuffBars[i] == spellID) then
							self:SetPoint("LEFT",((i-1) * 20) + 5,0);
						end
					end
					if (duration > 1.6) then
						self:SetMinMaxValues(0,duration);
					end
					if (seconds > 0.1) then
						self.timetext:SetText(timer);
						self:SetValue(seconds);
					else
						self:Hide();
						for i=1,getn(loadedBuffBars) do
							if (loadedBuffBars[i] == spellID) then
								table.remove(loadedBuffBars,i);
							end
						end
						self:SetScript("OnUpdate",nil);
					end
				end);]]
			--elseif (barObj[spec].main[spellID] and Auras.db.char.aura[spec][(barObj[spec].main[spellID]:GetName() or barObj[spec].main[spellID][1]:GetName() or barObj[spec].main[spellID][2]:GetName())] and barObjIndex[spellID] == subevent) then
			elseif (barObj[spec].main[spellID] and Auras.db.char.aura[spec][objectName] and barObjIndex[spellID] == subevent) then
				--[[local x = 0;
				
				if (spellID == 5394) then
					local charges = GetSpellCharges(spellID);
					if (charges == 1) then
						table.insert(loadedMainBars,53941);
						RunMainDurationBar(SSA.HealingStreamTotemBarOne,loadedMainBars,53941,startTime);
					elseif (charges == 0) then
						table.insert(loadedMainBars,53942);
						RunMainDurationBar(SSA.HealingStreamTotemBarTwo,loadedMainBars,53942,startTime);
					end
				else
					local isNewBar = true;
					for i=1,getn(loadedMainBars) do
						if (loadedMainBars[i] == spellID) then
							isNewBar = false;
						end
					end
					
					if (isNewBar) then
						table.insert(loadedMainBars,spellID);
					end
					RunMainDurationBar(barObj[spec].main[spellID],loadedMainBars,spellID,startTime);
				end]]
				
				
				--[[if (spellID == 5394) then 
					
				end
				table.insert(loadedMainBars,spellID);
				barObj[spec].main[spellID]:Show();
				barObj[spec].main[spellID]:SetScript("OnUpdate", function(self,elapsed)
					local expires = startTime + self.duration;
					local timer,seconds = Auras:parseTime((expires - GetTime()),true);
				
					for i=1,getn(loadedMainBars) do
						if (loadedMainBars[i] == spellID) then
							self:SetPoint("RIGHT",((i-1) * -20) + -5,0);
						end
					end
					if (seconds > 0) then
						self.timetext:SetText(timer);
						self:SetValue(seconds);
					else
						self:SetScript("OnUpdate",nil);
						self:Hide();
						for i=1,getn(loadedMainBars) do
							if (loadedMainBars[i] == spellID) then
								table.remove(loadedMainBars,i);
							end
						end
					end
				end);]]
			end
		elseif (subevent == "SPELL_AURA_APPLIED" and (spells[spec][spellID] or barObj[spec].buff[spellID] or barObj[spec].main[spellID])) then
			--if (barObj[spec].buff[spellID] and Auras.db.char.aura[spec][barObj[spec].buff[spellID]:GetName()] and barObjIndex[spellID] == subevent) then
			
			if (barObj[spec].buff[spellID] and Auras.db.char.aura[spec][objectName] and barObjIndex[spellID] == subevent) then
				--[[local x = 0;
				local buffer,curTime,timeDiff = GetTime(),nil,nil;
				local expires,duration
				table.insert(loadedBuffBars,spellID);
				barObj[SSA.spec].buff[spellID]:Show();
				barObj[SSA.spec].buff[spellID]:SetScript("OnUpdate", function(self,elapsed)
					_,_,_,_,_,duration,expires = UnitBuff('player',Auras:GetSpellName(spellID));
					--curTime = GetTime();
					--timeDiff = curTime - buffer;
					if (type(duration) ~= "number") then
						if (duration > 1.6) then
							self:SetMinMaxValues(0,duration);
						end
						--if (timeDiff >= 0.1) then
							--local expires = startTime + self.duration;
						local timer,seconds = Auras:parseTime((expires - GetTime()),true);

						for i=1,getn(loadedBuffBars) do
							if (loadedBuffBars[i] == spellID) then
								--SSA.BuffTimerBarGrpEle:SetPoint("CENTER",x,-125);
								self:SetPoint("LEFT",((i-1) * 20) + 5,0);
							end
						end
						if (seconds > 0.1) then
							self.timetext:SetText(timer);
							self:SetValue(seconds);
						else
							self:Hide();
							for i=1,getn(loadedBuffBars) do
								if (loadedBuffBars[i] == spellID) then
									table.remove(loadedBuffBars,i);
								end
							end
							self:SetScript("OnUpdate",nil);
						end
					else
						self:SetScript("OnUpdate",nil);
					end
				end);]]
			--elseif (barObj[spec].main[spellID] and Auras.db.char.aura[spec][barObj[spec].main[spellID]:GetName()] and barObjIndex[spellID] == subevent) then
			elseif (barObj[spec].main[spellID] and Auras.db.char.aura[spec][objectName] and barObjIndex[spellID] == subevent) then
				--[[local x = 0;
				local expires,duration
				--print("Subevent: "..subevent);
				table.insert(loadedMainBars,spellID);

				barObj[spec].main[spellID]:Show();
				barObj[spec].main[spellID]:SetScript("OnUpdate", function(self,elapsed)
					--local expires = startTime + self.duration;
					_,_,_,_,_,duration,expires = UnitBuff('player',Auras:GetSpellName(spellID));
					local timer,seconds = Auras:parseTime((expires - GetTime()),true);
				
					for i=1,getn(loadedMainBars) do
						if (loadedMainBars[i] == spellID) then
							self:SetPoint("RIGHT",((i-1) * -20) + -5,0);
						end
					end
					if (duration > 1.6) then
						self:SetMinMaxValues(0,duration);
					end
					if (seconds > 0.1) then
						self.timetext:SetText(timer);
						self:SetValue(seconds);
					else
						self:Hide();
						for i=1,getn(loadedMainBars) do
							if (loadedMainBars[i] == spellID) then
								table.remove(loadedMainBars,i);
							end
						end
						self:SetScript("OnUpdate",nil);
					end
				end);]]
			elseif (spellID == 205495 and Auras.db.char.aura[1].StormkeeperChargeGrp) then -- Stormkeeper
				local buff,count
				local elapsed
				--[[for i=1,3 do
					elapsed = 0
					StormkeeperCharges["Charge"..i].Lightning:SetScript("OnUpdate", function(self, elaps)
						elapsed = elapsed + (elaps * 1000);
						self:SetSequenceTime(1, elapsed);
					end);
					StormkeeperCharges["Charge"..i].Lightning:SetSequence(1);
				end]]
				--[[SSA.StormkeeperChargeGrp:SetScript("OnUpdate",function(self,elapsed)
					buff,_,_,count = UnitBuff('player',Auras:GetSpellName(spellID))
					
					if (not self:IsShown()) then
						self:Show();
					end
					
					if (count == 3) then
						--self.Charge1.Lightning:SetModel("spells/Monk_chiblast_precast.m2");
						--self.Charge2.Lightning:SetModel("spells/Monk_chiblast_precast.m2");
						--self.Charge3.Lightning:SetModel("spells/Monk_chiblast_precast.m2");
						self.Charge1:SetAlpha(1);
						self.Charge2:SetAlpha(1);
						self.Charge3:SetAlpha(1);
					elseif (count == 2) then
						--self.Charge1:Show();
						--self.Charge2:Show();
						self.Charge3:SetAlpha(0.1);
					elseif (count == 1) then
						--self.Charge1:Show();
						self.Charge2:SetAlpha(0.1);
						--self.Charge3:Hide();
					elseif (count == 0 or not buff) then
						self.Charge1:SetAlpha(0.1);
						self.Charge2:SetAlpha(0.1);
						self.Charge3:SetAlpha(0.1);
						self:SetScript("OnUpdate",nil);
					end
				end);]]
			elseif (spellID == 210714) then -- Icefury
				isIcefury = true;
				execTime[spellID] = GetTime();
				--SSA.Icefury.CD.text:Show();
				--SSA.IcefuryBar:Show();
				--[[SSA.IcefuryBar:SetValue(4);
				SSA.IcefuryBar.Timer:SetScript("OnUpdate",function(self,elapsed)
					--local name = GetSpellInfo(spellID);
					local buff,_,_,_,_,duration,expires = UnitBuff('player',Auras:GetSpellName(spellID));
					local timer,seconds = Auras:parseTime((expires - GetTime()),true);

					if (seconds > 0.1) then
						self:SetValue(seconds);
						self.text:SetText(timer);
					else
						self:SetScript("OnUpdate",nil);
					end
				end);]]
			elseif (spellID == 77762) then -- Lava Surge
				--[[local name
				if (SSA.spec == 3) then
					name = "Res";
				else
					name = 'Ele';
					if (UnitAffectingCombat('player')) then
						Auras:ToggleOverlayGlow(SSA["LavaBurst"..name].glow,true,false);
					end
				end]]
				--SSA["LavaSurge"..name]:Show();
				--SSA["LavaSurge"..name].Scaler:Play();
				--SSA["LavaBurst"..name].CD:Hide();
				--SSA["LavaBurst"..name].CD:SetCooldown(0,0)
				--ToggleCooldownSwipe(SSA["LavaBurst"..name].CD,false);
			elseif (spellID == 188389) then -- Flame Shock
				--UpdateFlameShock(SSA.FlameShock.glow,spellObj[spec][spellID],spellID);
			elseif (spellID == 188838) then
				UpdateFlameShock(SSA.FlameShockRes.glow,spellObj[spec][spellID],spellID);
			elseif (spellID == 53390) then -- Tidal Waves
				--local name = GetSpellInfo(spellID);
				local _,_,_,count = UnitBuff('player',Auras:GetSpellName(spellID));
							
				Auras:UpdateTidalWaveBar(0.5,{0.35,0.76,1},false,count);
			elseif (spellID == 201846 and Auras.db.char.aura[2].StormstrikeChargeGrp) then
				local name,count = GetSpellInfo(spellID),nil;				
				local elapsed = 0;
				
				--[[StormstrikeCharge1.Lightning:SetScript("OnUpdate", function(self, elaps)
					elapsed = elapsed + (elaps * 1000);
					self:SetSequenceTime(1, elapsed);
				end);
				
				StormstrikeCharge2.Lightning:SetScript("OnUpdate", function(self, elaps)
					elapsed = elapsed + (elaps * 1000);
					self:SetSequenceTime(1, elapsed);
				end);]]
				
				--[[SSA.StormstrikeChargeGrp:SetScript("OnUpdate",function(self,elaps)
					count = select(4,UnitBuff('player',name));

					if (count == 2) then
						self.Charge1:SetAlpha(1);
						self.Charge2:SetAlpha(1);
					elseif (count == 1) then
						if (select(4,GetTalentInfo(5,1,1))) then
							self.Charge2:SetAlpha(0);
						else
							self.Charge1:SetAlpha(1);
						end
					else
						self.Charge1:SetAlpha(0);
						self:SetScript("OnUpdate",nil);
					end
				end);]]
				if (UnitAffectingCombat('player')) then
					--Auras:ToggleOverlayGlow(SSA.Stormstrike.glow,true);
				end
			elseif (spellID == 208723) then
				if (UnitAffectingCombat('player')) then
					--Auras:ToggleOverlayGlow(SSA.Earthquake.glow,true,false);
					--Auras:AdjustIconDisplay(SSA.Earthquake,1,1,1,1);
				end
			elseif (spellID == 216251 and Auras.db.char.aura[3].Undulation) then -- Undulation
				--[[if (not SSA.Undulation:IsShown() and SSA.spec == 3) then
					SSA.Undulation:Show();
				end
				SSA.Undulation:SetAlpha(1);]]
			elseif (spellID == 204945 and Auras.db.char.aura[2].DoomWindsTexture) then
				--SSA.DoomWindsTex:Show();
				--SSA.DoomWindsTex.Scaler:Play();
			end
		elseif ((subevent == "SPELL_AURA_APPLIED_DOSE" or subevent == "SPELL_AURA_REMOVED_DOSE") and spells[spec][spellID]) then
			if (spellID == 53390) then -- Tidal Waves
				local _,_,_,count = UnitBuff('player',Auras:GetSpellName(spellID));
				--SSA.TidalWavesBar:SetValue(count);
			end	
		elseif (subevent == "SPELL_AURA_REFRESH" and spells[spec][spellID]) then
			if (spellID == 77762) then
				--[[local name
				if (SSA.spec == 3) then
					name = "Res";
				else
					name = 'Ele';
				end
				SSA["LavaBurst"..name].CD:Hide();
				SSA["LavaBurst"..name].CD:SetCooldown(0,0)
				ToggleCooldownSwipe(SSA["LavaBurst"..name].CD,false);]]
			elseif (spellID == 188389) then
				UpdateFlameShock(SSA.FlameShock.glow,SSA.FlameShock,spellID);
			elseif (spellID == 188838) then
				UpdateFlameShock(SSA.FlameShockRes.glow,SSA.FlameShockRes,spellID);
			end
			--if (barObj[spec].main[spellID] and Auras.db.char.aura[spec][barObj[spec].main[spellID]:GetName()] and barObjIndex[spellID] == "SPELL_AURA_APPLIED") then
			if (barObj[spec].main[spellID] and Auras.db.char.aura[spec][objectName] and barObjIndex[spellID] == "SPELL_AURA_APPLIED") then
				local x = 0;
				--[[local isNewBar = true;
				for barID in pairs(loadedMainBars) do
					if (barID == spellID) then
						isNewBar = false;
					end
				end
				
				if (isNewBar) then
					table.insert(loadedMainBars,spellID);
				end]]
				local foundBar = false;
				barObj[spec].main[spellID]:Show();
				barObj[spec].main[spellID]:SetScript("OnUpdate",nil);
				barObj[spec].main[spellID]:SetScript("OnUpdate", function(self,elapsed)
					--local expires = startTime + self.duration;
					local _,_,_,_,_,duration,expires = UnitBuff('player',Auras:GetSpellName(spellID));
					local timer,seconds = Auras:parseTime((expires - GetTime()),true);
					
					for i=1,getn(loadedMainBars) do
						if (loadedMainBars[i] == spellID) then
							self:SetPoint("RIGHT",((i-1) * -20) + -5,0);
							foundBar = true;
							break;
						end
					end
					if (duration > 1.6) then
						self:SetMinMaxValues(0,duration);
					end
					if (not foundBar) then
						table.insert(loadedMainBars,spellID);
						self:SetPoint("RIGHT",((getn(loadedMainBars)-1) * -20) + -5,0);
					end
					if (seconds > 0.1) then
						self.timetext:SetText(timer);
						self:SetValue(seconds);
					else
						
						self:Hide();
						for i=1,getn(loadedMainBars) do
							if (loadedMainBars[i] == spellID) then
								table.remove(loadedMainBars,i);
							end
						end
						self:SetScript("OnUpdate",nil);
					end
				end);
			end
		elseif (subevent == "SPELL_AURA_REMOVED" and spells[spec][spellID]) then
			if (spellID == 210714) then
				--[[isIcefury = false;
				execTime[spellID] = nil;
				SSA.Icefury.CD:SetScript("OnUpdate",nil);
				SSA.IcefuryBar:SetScript("OnUpdate",nil);
				SSA.Icefury.CD:Hide();
				SSA.IcefuryBar:Hide();]]
			elseif (spellID == 77762) then
				--[[local name
				if (SSA.spec == 3) then
					name = "Res";
				else
					name = 'Ele';
					Auras:ToggleOverlayGlow(SSA["LavaBurst"..name].glow,false);
				end]]
			elseif (spellID == 53390) then -- Tidal Waves
				Auras:UpdateTidalWaveBar(0,{1,0,0},Auras.db.char.triggers.res.animTidalWaves,2);
			elseif (spellID == 201846 and Auras.db.char.aura[2].StormstrikeChargeGrp) then
				--Auras:ToggleOverlayGlow(SSA.Stormstrike.glow,false);
				--StormstrikeCharge1.Lightning:SetScript("OnUpdate", nil);
				--StormstrikeCharge2.Lightning:SetScript("OnUpdate", nil);
			elseif (spellID == 114050) then -- Ascendance (Elemental)
				--ToggleCooldownSwipe(SSA["LavaBurstEle"].CD,true);
			elseif (spellID == 208723) then
				Auras:ToggleOverlayGlow(SSA.Earthquake.glow,false);
				local power = UnitPower('player',11);
				if (power >= 50) then
					--Auras:AdjustIconDisplay(SSA.Earthquake,1,1,1,1);
				else
					--Auras:AdjustIconDisplay(SSA.Earthquake,0.5,0.5,0.5,0.5);
				end
			elseif (spellID == 216251) then -- Undulation
				--[[SSA.Undulation.Flash:Stop();
				SSA.Undulation:Hide();]]
				SSA.Undulation:SetAlpha(0);
			elseif (spellID == 204945 and Auras.db.char.aura[2].DoomWindsTexture) then
				--SSA.DoomWindsTex:Hide();
				--SSA.DoomWindsTex.Scaler:Stop();
			end
		elseif (subevent == "SPELL_DAMAGE" and spec == 3 and select(9,...) == L["Earthen Shield Totem"]) then
			--[[for i=1,5 do
				local _,name = GetTotemInfo(i);
				if (name == "Earthen Shield Totem") then]]
					--Auras.db.char.info.totems.eShield.dmg = (Auras.db.char.info.totems.eShield.dmg or 0) + select(15,...);
					--UpdateEarthenShield();
					--break;
				--end
			--end
		elseif (subevent == "SWING_DAMAGE" and spec == 3 and select(9,...) == L["Earthen Shield Totem"]) then
			--[[for i=1,5 do
				local _,name = GetTotemInfo(i);
				if (name == "Earthen Shield Totem") then]]
					--Auras.db.char.info.totems.eShield.dmg = (Auras.db.char.info.totems.eShield.dmg or 0) + (select(15,...) or 0);
					--UpdateEarthenShield();
					--[[break;
				end
			end]]
		--[[elseif (subevent == "SPELL_ABSORBED" and spec == 3 and select(13,...) == "Earthen Shield Totem") then
			Auras.db.char.info.totems.eShield.dmg = (Auras.db.char.info.totems.eShield.dmg or 0) + (select(19,...) or 0);
			print("ABSORBED: "..Auras.db.char.info.totems.eShield.dmg);
			UpdateEarthenShield();]]
		elseif (subevent == "UNIT_DIED") then
			local _,_,_,_,_,_,_,_,arg = ...
			--[[print("ARG: "..tostring(arg));
			if (arg == "Cloudburst Totem") then
				SSA.Cloudburst:Hide();
				SSA.Cloudburst.text:SetText('0');
				SSA.Cloudubrst:SetScript("OnUpdate",nil);
			else]]
				--[[for elemental,barObj in pairs(GUIDs) do
					--if (select(9,...) == elemental) then
					if (arg == elemental) then
						barObj:SetScript("OnUpdate",nil);
						barObj:Hide();
						GUIDs[elemental] = nil;
					end
				end]]
			--end
		end
	end
end

function Auras:SPELL_UPDATE_COOLDOWN()
	--ExecuteCooldown();
	--[[local spec = SSA.spec;
	for spellID in pairs(spells[spec]) do
		local start,duration = GetSpellCooldown(spellID);
		
		if (start > 0 and duration > 2) then
			local object = spellObj[spec][spellID];
			
			object:SetScript("OnUpdate",function(self,elapsed)
				local expires = start + duration;
				local timer = expires - GetTime();
				local remaining,seconds = Auras:parseTime(timer,false);
				
				if (smallSpells[spellID]) then
					if (seconds > 60) then
						fontSize = 11;
					else
						fontSize = 16;
					end
				else
					if (seconds > 60) then
						fontSize = 14;
					else
						fontSize = 18;
					end
				end
				
				if (spellID ~= 188838) then
					if ((seconds or 0) > 0.1) then
						self.text:SetFont("Interface\\addons\\ShamanAuras\\media\\fonts\\PT_Sans_Narrow.TTF", fontSize,"OUTLINE");
						self.text:SetText(Auras:parseTime(timer,false));
					else
						--Auras.db.char.cooldowns[spellID] = nil;
						ToggleCooldownSwipe(self,false);
						self.text:SetText('');
						self:SetScript("OnUpdate",nil);
					end
				end
			end);
		end
	end]]
end
